function r = d2x_d2vf_bacterial_fit_exp(t,fd_cell,theta,theta_fixe)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fhnfun
%
% The FitzHugh-Nagumo equations in vector form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = eval_fdcell(t,fd_cell,0);
r = cell(3,3,3);
r(1:3,1:3,1:3) = {0};


gamma_e = exp(theta(1));
psi_e = exp(theta(2));
c_e = exp(theta(3));


beta = theta_fixe(1);
Pmax = theta_fixe(2);
delta = theta_fixe(3);
delta_p = theta_fixe(4);
nu_s = theta_fixe(5);
K = theta_fixe(6);
E_s =  theta_fixe(7);
A = theta_fixe(8);
A_s50 = theta_fixe(9);
gamma_max = theta_fixe(10);
A_s = theta_fixe(11);
gamma_50 = theta_fixe(12);
lambda = theta_fixe(13);
A_r50 = theta_fixe(14);
E_r = theta_fixe(15); 
rho =  theta_fixe(16); 

mu_s = E_s*A/(A+A_s50);
mu_r = E_r*A/(A+A_r50);
zeta = gamma_max*A_s/(A_s+gamma_50);

    
    %r{1} = beta.*y{2}.*(1-y{1}./Pmax) - delta*y{2}.*y{1}-delta_p.*y{1};
    %r{1,1} = -beta.*y{2}./Pmax - delta*y{2}-delta_p;
    r{1,1,2} = -beta./Pmax - delta;
    
    %r{1,2} = beta.*(1-y{1}./Pmax) - delta*y{1};
    r{1,2,1} = -beta./Pmax - delta;
    
	%r{2} = nu_s*(y{2}-c_e.*y{3}).*(1-y{2}/K)-mu_s*(y{2}-y{3})-(gamma_e+zeta).*y{1}.*y{2}-psi_e*y{2}-mu_r.*y{3};
    %r{2,1} = -(gamma_e+zeta).*y{2};
    r{2,1,2} = -(gamma_e+zeta);
    
    %r{2,2} = -nu_s*(y{2}-c_e.*y{3})/K +nu_s*(1-y{2}/K)-mu_s-(gamma_e+zeta).*y{1}-psi_e;
    r{2,2,1} = -(gamma_e+zeta);
    r{2,2,2} = -2*nu_s/K;
    r{2,2,3} =  nu_s*c_e/K;
      
    %r{2,3} = -nu_s.*c_e.*(1-y{2}/K) +mu_s-mu_r;
    r{2,3,2} = nu_s*c_e/K;
    
    %r{3} = (1-c_e).*nu_s.*y{3}.*(1-y{2}/K)- mu_r.*y{3}-(gamma_e+zeta).*y{1}.*y{3}+lambda.*(y{2}-y{3}).*y{3}-rho.*y{3}-psi_e.*y{3};
    %r{3,1} = -(gamma_e+zeta).*y{3};
    r{3,1,3} = -(gamma_e+zeta);
    
    %r{3,2} = -(1-c_e).*nu_s.*y{3}/K + lambda.*y{3};
    r{3,2,3} = -(1-c_e).*nu_s/K + lambda;
    
    %r{3,3} = (1-c_e).*nu_s.*(1-y{2}/K) - mu_r  -(gamma_e+zeta).*y{1} + lambda.*(y{2}-2*y{3})- rho-psi_e;
    r{3,3,1} =  -(gamma_e+zeta);
    r{3,3,2} =  -(1-c_e).*nu_s/K + lambda;
    r{3,3,3} = -2*lambda;

