function [est_param,fval] = est_param_fitz_differentiating_moment(bs,param_ini,fonc_test,fonc_test_sin,nb_cond,nb_cond_sin,val_b,val_c,val_y0,cs_tr,grad_use)
			Obs =  bs.getObservation();         
            Times_c = Obs.getTimes();
            Times = Times_c{1};
            
            ordre_max = 1;
			nb_moment = 5;
            
	
    if nargin < 7 || isempty(val_b)
		b_fixe = 0;
		else
		b_fixe = 1;
	end	        
            
	if nargin < 8 || isempty(val_c)
		c_fixe = 0;
		else
		c_fixe = 1;
	end	
	
	if nargin < 9 || isempty(val_y0)
		y0_fixe = 0;
		else
		y0_fixe = 1;
    end	
    
    
	if nargin < 10
		cs_tr = 0;
    end	
    
    if nargin < 11
        grad_use = 0;
    end
    
    if cs_tr ==1
        nb_moment = 6;
    else
        nb_moment = 5;
    end
			
	function res_integ  =func_integ(t)
        X_pred = bs.calcul_prediction(t,0);
        fonc_dir_test = fonc_test(t,Times(1),Times(end),nb_cond,0,ordre_max)';
		fonc_der_test = fonc_test(t,Times(1),Times(end),nb_cond,1,ordre_max)';
		fonc_der_sec_test = fonc_test(t,Times(1),Times(end),nb_cond,2,ordre_max)';
        
        res_integ = [fonc_dir_test X_pred*fonc_dir_test X_pred*fonc_der_test X_pred*fonc_der_sec_test];            
    end


     function res_integ  =func_integ_der3(t)
        X_pred = bs.calcul_prediction(t,0);
        fonc_der_test = fonc_test(t,Times(1),Times(end),nb_cond,1,2)';
		fonc_der_sec_test = fonc_test(t,Times(1),Times(end),nb_cond,2,2)';
		fonc_der_trois_test = fonc_test(t,Times(1),Times(end),nb_cond,3,2)';
        
        res_integ = [X_pred*fonc_der_test  X_pred*fonc_der_sec_test X_pred*fonc_der_trois_test];            
     end
 
 
   function res_integ  =func_integ_sin(t)
        X_pred = bs.calcul_prediction(t,0);
        fonc_dir_test = fonc_test_sin(t,Times(1),Times(end),nb_cond_sin,0,ordre_max)';
		fonc_der_test = fonc_test_sin(t,Times(1),Times(end),nb_cond_sin,1,ordre_max)';
        
        res_integ = [fonc_dir_test X_pred*fonc_dir_test X_pred*fonc_der_test ];            
    end
	

 
    ps_R_tr = quadv(@func_integ_der3,Times(1),Times(end));
	
	ps_R_der_tr = ps_R_tr(:,1);
	ps_R_der_sec_tr = ps_R_tr(:,2);
	ps_R_der_trois_tr = ps_R_tr(:,3);
	
	ps_R = quadv(@func_integ,Times(1),Times(end));
	
	func_test_integ = ps_R(:,1);
	ps_R_dir = ps_R(:,2);
	ps_R_der = ps_R(:,3);
	ps_R_der_sec = ps_R(:,4);
    
    
    ps_R_sin = quadv(@func_integ_sin,Times(1),Times(end));
	
	func_test_integ_sin = ps_R_sin(:,1);
	ps_R_dir_sin = ps_R_sin(:,2);
	ps_R_der_sin = ps_R_sin(:,3);
    
    
	function [val_f Grad_f] = func_eco(param)
        %param
	
		ind_param = 1;
		a = param(ind_param);
		ind_param = ind_param+1;
		
        if b_fixe == 0
            b = param(ind_param);
           ind_param = ind_param+1;
        else
        	b = val_b;
        end
		
		if c_fixe == 0
			c = param(ind_param);
			ind_param = ind_param+1;
		else
			c = val_c;
		end
		
		if y0_fixe == 0
		y0 = param(ind_param);
		else
			y0 = y0_fixe;
		end
		
		function dy = equ(t,y)
			val_R_t = bs.calcul_prediction(t,0);
            if grad_use ==1
                dy = zeros(3,1);
                dy(1) = c*(y(1) - (y(1)^3)/3 + val_R_t);
                equ_sens = (1-y(1)^2)*y(2:3);
                equ_sens(1) = equ_sens(1)+(y(1) - (y(1)^3)/3 + val_R_t);
                dy(2:3) = equ_sens;
            else
                dy(1) = c*(y(1) - (y(1)^3)/3 + val_R_t);
            end
            
            
		end

	if grad_use == 1
		sol_V = ode15s(@equ,Times,[y0 0 1]');
    else
        sol_V = ode15s(@equ,Times,y0);
    end
		
		function res_t = func_integ_V(t)
			fonc_dir_test = fonc_test(t,Times(1),Times(end),nb_cond,0,ordre_max)';
			fonc_der_test = fonc_test(t,Times(1),Times(end),nb_cond,1,ordre_max)';
			val_V_sens = deval(sol_V,t);
            val_V  =val_V_sens(1);
			res_t = [val_V*fonc_dir_test (val_V^3)*fonc_dir_test val_V*fonc_der_test]; 
        end
        
        function res_t = func_integ_V_sin(t)
			fonc_dir_test = fonc_test_sin(t,Times(1),Times(end),nb_cond_sin,0)';
			val_V_sens = deval(sol_V,t);
            val_V  =val_V_sens(1);
			res_t = val_V*fonc_dir_test; 
		end
		
		function res_t = func_integ_V_tr(t)
            val_R = bs.calcul_prediction(t,0);
			fonc_dir_test = fonc_test(t,Times(1),Times(end),nb_cond,0,2)';
			val_V_sens = deval(sol_V,t);
            val_V  =val_V_sens(1);
			res_t = (val_V-((val_V^3)/3)+val_R)*(1-val_V^2)*fonc_dir_test; 
        end
        
        
        
        function res_t = func_integ_V_sens(t)
			fonc_dir_test = fonc_test(t,Times(1),Times(end),nb_cond,0,ordre_max)';
			fonc_der_test = fonc_test(t,Times(1),Times(end),nb_cond,1,ordre_max)';
			val_V_sens = deval(sol_V,t);
            val_V_c = val_V_sens(2);
            val_V_y0 = val_V_sens(3);
            val_V  =val_V_sens(1);
			res_t = [val_V_c*fonc_dir_test (val_V^2)*val_V_c*fonc_dir_test val_V_c*fonc_der_test val_V_y0*fonc_dir_test (val_V^2)*val_V_y0*fonc_dir_test val_V_y0*fonc_der_test]; 
        end
        
        function res_t = func_integ_V_sin_sens(t)
			fonc_dir_test = fonc_test_sin(t,Times(1),Times(end),nb_cond_sin,0)';
			val_V_sens = deval(sol_V,t);
            val_V_c = val_V_sens(2);
            val_V_y0 = val_V_sens(3);
			res_t = [val_V_c*fonc_dir_test val_V_y0*fonc_dir_test]; 
		end
		
		ps_V = quadv(@func_integ_V,Times(1),Times(end));
        
        ps_cs6 = quadv(@func_integ_V_tr,Times(1),Times(end));

		ps_V_dir = ps_V(:,1);
		ps_V_cube_dir = ps_V(:,2)/3;
		ps_V_der = ps_V(:,3);
		
        ps_V_sin = quadv(@func_integ_V_sin,Times(1),Times(end));
        
		coeff_el = zeros(nb_cond_sin+(nb_moment-1)*nb_cond,1);

		coeff_el(1:nb_cond_sin) = ps_R_der_sin -(1/c)*ps_V_sin+(a/c)*func_test_integ_sin -(b/c)*ps_R_dir_sin;
		
		ind_nb_cond = 1;
		coeff_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond)) = ps_R_der_sec +(1-(b/(c^2)))*ps_V_dir-ps_V_cube_dir+(1-(b/c)^2)*ps_R_dir+((a*b)/(c^2))*func_test_integ;
		
		ind_nb_cond = ind_nb_cond +1;
		coeff_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond)) = ps_R_der_sec +ps_V_dir-ps_V_cube_dir+ps_R_dir-(b/c)*ps_R_der;
		
		ind_nb_cond = ind_nb_cond +1;
		coeff_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond)) = ps_R_der_sec -(b/(c^2))*ps_V_dir+((a*b)/(c^2))*func_test_integ-((b/c)^2)*ps_R_dir -(1/c)*ps_V_der;
		
		ind_nb_cond = ind_nb_cond +1;
		coeff_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond)) = ps_R_der_sec  -(1/c)*ps_V_der - (b/c)*ps_R_der;
	
        if cs_tr ==1
        ind_nb_cond = ind_nb_cond +1;
		coeff_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond)) = ps_R_der_trois_tr  -c*ps_cs6 + ps_R_der_tr- (b/c)*ps_R_der_sec_tr;
        end
	
	
        %coeff_el
		val_f = coeff_el'*coeff_el;
        
       
        if nargout > 1
            Gradient_el = zeros(nb_cond_sin+(nb_moment-1)*nb_cond,4);
            ps_V_sens = quadv(@func_integ_V_sens,Times(1),Times(end));
            ps_V_c_dir = ps_V_sens(:,1);
            ps_V_c_sq_dir = ps_V_sens(:,2);
            ps_V_c_der = ps_V_sens(:,3);
            
            ps_V_y0_dir = ps_V_sens(:,4);
            ps_V_y0_sq_dir = ps_V_sens(:,5);
            ps_V_y0_der = ps_V_sens(:,6);
            
            ps_V_sin_sens = quadv(@func_integ_V_sin_sens,Times(1),Times(end));
            ps_V_c_sin_dir = ps_V_sin_sens(:,1);        
            ps_V_y0_sin_dir = ps_V_sin_sens(:,2);

            
        Gradient_el(1:nb_cond_sin,1) = func_test_integ_sin/c;
        Gradient_el(1:nb_cond_sin,2) = -ps_R_dir_sin/c;
        Gradient_el(1:nb_cond_sin,3) = (ps_V_sin-a*func_test_integ_sin +b*ps_R_dir_sin)/(c^2)-ps_V_c_sin_dir/c;
        Gradient_el(1:nb_cond_sin,4) = -ps_V_y0_sin_dir/c;    
            
        ind_nb_cond = 1;
		Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),1) = (b/(c^2))*func_test_integ;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),2) = -ps_V_dir/(c^2)-(2*b/(c^2))*ps_R_dir+(a/(c^2))*func_test_integ;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),3) = (2*b/(c^3))*ps_V_dir+(2*(b^2)/(c^3))*ps_R_dir-((2*b*a)/(c^3))*func_test_integ +(1-(b/(c^2)))*ps_V_c_dir-ps_V_c_sq_dir;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),4) = (1-(b/(c^2)))*ps_V_y0_dir-ps_V_y0_sq_dir;
		
		ind_nb_cond = ind_nb_cond +1;
		Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),1) = 0;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),2) = -ps_R_der/c;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),3) = (b/c^2)*ps_R_der+ps_V_c_dir-ps_V_c_sq_dir;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),4) = ps_V_y0_dir-ps_V_y0_sq_dir;
		
		ind_nb_cond = ind_nb_cond +1;
		Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),1) = (b/(c^2))*func_test_integ;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),2) = -ps_V_dir/(c^2)+(a/(c^2))*func_test_integ-(2*b/(c^2))*ps_R_dir;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),3) = (2*b/(c^3))*ps_V_dir-(2*a*b/(c^3))*func_test_integ+(2*b^2/(c^3))*ps_R_dir+ps_V_der/(c^2)-(b/(c^2))*ps_V_c_dir-ps_V_c_der/c;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),4) = -(b/(c^2))*ps_V_y0_dir-ps_V_y0_der/c;
		
		ind_nb_cond = ind_nb_cond +1;
		Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),1) = 0;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),2) = -ps_R_der/c;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),3) = ps_V_der/(c^2)+(b/(c^2))*ps_R_der-ps_V_c_der/c;
        Gradient_el((nb_cond_sin+(ind_nb_cond-1)*nb_cond+1):(nb_cond_sin+ind_nb_cond*nb_cond),4) =-ps_V_y0_der/c;
          
        Grad_f = Gradient_el'*coeff_el;
        
        end
        
    end


        if grad_use == 1
            grad_obs = 'on';
        else
            grad_obs = 'off';
        end
	
	
	        nb_fun_eval = 2500;
            options = optimset('TolFun',1e-10,'TolX',1e-10,'GradObj',grad_obs,'MaxFunEvals',nb_fun_eval,'MaxIter',10000,'Hessian','off');
            [est_param,fval] = fminunc(@func_eco,param_ini,options);


end