function param_estimator = compute_param_fitzHugh_direct(bs,theta_ini,func_test,L,grad_use,Weight)
    
            obs =  bs.getObservation();         
            T_gen = obs.getTimes();
            TS = T_gen{1};
            
            T_0 = TS(1);
            T_1 = TS(length(TS));
            
            if nargin < 6
                Weight = eye(L);
            end
            
             if nargin < 5
                grad_use = 'off';
            end


    function res_aux = coeff_ftd_premiere(t)

         fonc_dir_test = func_test(t,T_0,T_1,L,1,0)';        
         X_pred = bs.calcul_prediction(t,0);         
         res_aux= X_pred*fonc_dir_test;
          
    end

     function res_aux = coeff_ftd_cube(t)

         fonc_der_test = func_test(t,T_0,T_1,L,0,0)';        
         X_pred = bs.calcul_prediction(t,0);           
         res_aux = (X_pred(1)-(X_pred(1)^3)/3)*fonc_der_test;

     end


    function res_aux = integ_der(s,theta_gen)
        a = theta_gen(1);
        b = theta_gen(2);
        c = theta_gen(3);
        r0 = theta_gen(4);
        
        function res_aux = inner_b(u)
            X_pred = bs.calcul_prediction(u,0);
            res_aux = exp((u-s)*b/c)*(X_pred(1)-a);
        end
        
        part_integ = quadv(@inner_b,T_0,s);
        res_t = r0*c*exp(-s*b/c) - part_integ;
        fonc_dir_test = func_test(s,T_0,T_1,L,0,0)';  
        res_aux  = res_t*fonc_dir_test;
        
    end

    partie_der_constante = quadv(@coeff_ftd_premiere,T_0,T_1);
    partie_dir_constante = quadv(@coeff_ftd_cube,T_0,T_1);
    
    function [res Gradient] = func_eco(param)
        param
        
        partie_nl = quadv(@(t)integ_der(t,param),T_0,T_1);
        vecteur = partie_der_constante + param(3)*partie_dir_constante +partie_nl;
        
        vecteur = reshape(vecteur,length(vecteur),1);
        res = vecteur'*Weight*vecteur;

        
        if nargout > 1
            
            Gradient = zeros(4,1);
            [ Jacobien_integ res_rank] = compute_rank_fitzHugh(bs,param,func_test,L);
            
         for nb_cond_i = 1: L
                     for nb_cond_j = 1 : L

                   Jacob_i = Jacobien_integ(nb_cond_i,:)';     
                   Jacob_j = Jacobien_integ(nb_cond_j,:)';  
                   Gradient =  Gradient + Weight(nb_cond_i,nb_cond_j)*(Jacob_j*vecteur(nb_cond_i)+Jacob_i*vecteur(nb_cond_j));
                   %Gradient =  Gradient + (Jacob_j*res(nb_cond_i)+Jacob_i*res(nb_cond_j));
                     end
         end
        end
        
    end

    options = optimset('TolFun',1e-10,'TolX',1e-10,'GradObj',grad_use,'MaxFunEvals',inf,'MaxIter',10000,'Hessian','off');
    %param_estimator = fmincon(@func_eco,theta_ini,Ain,bin,Aeq,beq,lb,ub,[],options);
    %param_estimator = func_eco(theta_ini)
    param_estimator = fminunc(@func_eco,theta_ini,options);



end