function [res_jac res_rank] = compute_rank_fitzHugh(bs,theta_ini,func_test,L)

            obs =  bs.getObservation();         
            T_gen = obs.getTimes();
            TS = T_gen{1};
            
            T_0 = TS(1);
            T_1 = TS(length(TS));

    function res_aux = integ_der_a(s,theta_gen)
       % a = theta_gen(1);
        b = theta_gen(2);
        c = theta_gen(3);
        
        res_aux = (c/b)*(1-exp(-s*b/c));
        
    end

    function res_aux = integ_der_b(s,theta_gen)
        a = theta_gen(1);
        b = theta_gen(2);
        c = theta_gen(3);
        r0 = theta_gen(4);
        
        function res_aux = inner_b(u)
            X_pred = bs.calcul_prediction(u,0);
            res_aux = ((u-s)/c)*exp((u-s)*b/c)*(X_pred(1)-a);
        end
        
        part_integ = quadv(@inner_b,T_0,s);
        res_aux = -r0*s*exp(-s*b/c) - part_integ;
        
    end

    function res_aux = integ_der_c(s,theta_gen)
        a = theta_gen(1);
        b = theta_gen(2);
        c = theta_gen(3);
        r0 = theta_gen(4);
        
        function res_aux = inner_c(u)
            X_pred = bs.calcul_prediction(u,0);
            res_aux = (u-s)*exp((u-s)*b/c)*(X_pred(1)-a);
        end
        
        part_integ = quadv(@inner_c,T_0,s);
        
        res_aux =  (X_pred(1)-(X_pred(1).^3)/3) + r0*(1 + (s*b/c))*exp(-s*b/c) + (b/c*c)*part_integ;
        
    end

    function res_aux = integ_der_r0(s,theta_gen)
       % a = theta_gen(1);
        b = theta_gen(2);
        c = theta_gen(3);
        %r0 = theta_gen(4);

        res_aux = c*exp(-b*s/c);
        
    end

    function res_j = compute_integ_jacq(s)
        fonc_der_test = func_test(s,T_0,T_1,L,0,0)';
        res_j(:,1) = integ_der_a(s,theta_ini)*fonc_der_test';
        res_j(:,2) = integ_der_b(s,theta_ini)*fonc_der_test';
        res_j(:,3) = integ_der_c(s,theta_ini)*fonc_der_test';
        res_j(:,4) = integ_der_r0(s,theta_ini)*fonc_der_test';
        
    end
    
    res_jac = quadv(@compute_integ_jacq,T_0,T_1);
    res_rank = rank(res_jac);

end