function sol_ode_Times = extended_vectorfield_fitzhugh(bs,Times,a,b,c,lambda,true_val_final,nb_observ)

    function dy = equ(t,y)
        x1_x2 = reshape(y(1:2),2,1);
        p1_p2 = reshape(y(3:4),2,1);
        x_hat = bs.calcul_prediction(t,0)';
        
        mat_sens = zeros(2);
        mat_sens(1,1) = c*(1-x1_x2(1)^2);
        mat_sens(1,2) = c;
        mat_sens(2,1) = -1/c;
        mat_sens(2,1) = -b/c;
        
        dy = zeros(4,1);
        dy(1) = c*(x1_x2(1)-(x1_x2(1)^3)/3 + x1_x2(2))+p1_p2(1)/(2*lambda);
        dy(2) = (-1/c)*(x1_x2(1)-a + b*x1_x2(2))+p1_p2(2)/(2*lambda);
        
        dy(3:4) = 2*(x1_x2 - x_hat)-mat_sens'*p1_p2;
    end

    function dy= equ_inv(t,y)
        dy = - equ(Times(end)-t,y);
    end


    CI_fin = [true_val_final zeros(1,2)];
    sol_ode_inv = ode23tb(@equ_inv,Times,CI_fin);
    
    T_plot = Times(1:nb_observ);
    
    sol_ode_Times =  arrayfun(@(t)(deval(sol_ode_inv,t)),T_plot,'UniformOutput',false);
    sol_ode_Times = cell2mat(sol_ode_Times')';
    
    plot(T_plot,sol_ode_Times(:,1:4))

end