%% Est param compare with nls n1 p1 step function
clear

n_pop = 2;
n_bruit = 2;
n_pop_i = 1;
n_bruit_i = 1;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;
theta = [a b c];

control = @(t)([c*0.15*step_function(t) 0]');

 
fn       = @fhnfun;       % RHS function

% Now derivatives of the function with respect to system components and
% parameters

dfdx     = @fhndfdx;      % Derivative wrt inputs (Jacobian)
dfdp     = @fhndfdp;      % Derviative wrt parameters

% Now we need functions to compute all three sets of second derivatives:

d2fdx2   = @fhnd2fdx2;    % Hessian wrt inputs
d2fdxdp  = @fhnd2fdxdp;   % Hessian wrt inputs and parameters
d2fdp2   = @fhnd2fdp2;    % Hessian wrt parameters.



v_field = @vect_field_fitzHugh;
der_v_field = @der_vect_field_fitzHugh;
der_v_field_theta = @der_param_vect_field_fitzHugh;
der_v_field_state_theta = @der_state_param_vect_field_fitzHugh;
der_v_field_state_state = @der_sec_vect_field_fitzHugh;

deb = 0;
fin = 20;

dim_syst = 2;
mat_obs_c = eye(dim_syst);


lambda_trial =   [5 10 20 50];
nb_run = 100;

pop_trial = [100 50];
std_trial = [0.1 0.2];

    param_ini = theta;

    load_res = load('res_compare_estimation_pontryagin_fitzhugh_model_sf_n1_p1_bis.mat');      
    mat_est_oc_opt_data =  load_res.mat_est_oc_opt_data;   
    mat_est_oc_err_pred2 = load_res.mat_est_oc_err_pred2;
    mat_est_gsa = load_res.mat_est_gsa;
    mat_est_nls =  load_res.mat_est_nls;
 
    run_ini = load_res.run;
        
    for run = (run_ini+1) : nb_run    
    run

    pas = (fin-deb)/pop_trial(n_pop_i);
    std = std_trial(n_bruit_i);
    
    [T1 Y1] = fitz_nagumo(deb,fin,pas,x_0,a,b,c,std,control);
    intervalle_int2 = zeros(2,2);
    intervalle_int2(1,:) = [0 T1(50)];
    intervalle_int2(2,:) = [T1(51) T1(100)];
    
    Obs_l = Observation(T1,Y1); 
    bs_l = bSplines(Obs_l,3,x_0);

      Tcell = cell(1,2);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);

      Ycell = cell(1,2);
      Ycell{1} = Y1(:,1);
      Ycell{2} = Y1(:,2);
           
     % est param 
 
     try
          param_nls = est_param_nls_gradient_descent(Obs_l,v_field,der_v_field,der_v_field_theta,eye(2),theta,x_0,1)
     catch
         param_nls = zeros(1,3);   
     end
     
     try
     [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,theta,fn, dfdx, dfdp, d2fdx2, d2fdxdp,[],@champ_vect_fhn);
     u_gsa = @(t)(evaluate_controle_gsa(t,newDEfd_cell,fn,res_est));
     catch
         res_est = zeros(1,3);
         newDEfd_cell = zeros(1,20);
         u_gsa = @(t)(0);
     end
   

      [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,param_ini, x_0);

    min_err_pred2 = 10^100;

    for nl = 1 : length(lambda_trial)

        mat_U = lambda_trial(nl)*eye(dim_syst);
        try
        bs_u = est_control_pontryagin(bs_l,v_field,der_v_field,mat_obs_c,mat_U,mat_est(nl,:),x_0);
        res_err_pred2 = pontryagin_prediction_error_multi_inter(bs_l,bs_u,v_field,mat_obs_c,mat_est(nl,:),x_0,intervalle_int2);
        catch
            res_err_pred2 = 10^101;
            'err integ bvp'
            nl
        end

      if res_err_pred2 < min_err_pred2
          min_err_pred2 = res_err_pred2;
          est_param_oc_err_pred2 = mat_est(nl,:);
          lambda_err_pred2 = lambda_trial(nl);
      end
 
    end


     
     % stockage matrice

     mat_est_nls(run,1:3) = param_nls;     
     mat_est_oc_opt_data(run,1:3) = est_param_opt_data;  
     mat_est_oc_err_pred2(run,1:3) = reshape(est_param_oc_err_pred2,1,3); 
     mat_est_oc_err_pred2(run,4) = lambda_err_pred2;          
     mat_est_gsa(run,1:3) = res_est;

  
      repertoire = 'res_compare_estimation_pontryagin_fitzhugh_model_sf_n1_p1_bis.mat';
      save(repertoire,'run','mat_est_oc_opt_data','mat_est_oc_err_pred2','mat_est_nls','mat_est_gsa');

    end
    
    