function residu = calcul_residu_influenza(param_est,C_I_est,data_CD8,time_obs,bs_dend,delay)
    %data_C8 : cell_array de taille time_obs. Chaque cellules contient une
    %matrices de taille (nb_individu*3)

    function res_temp = dend_cell(t)
        res_temp = bs_dend.calcul_prediction(t);
        res_temp = arrayfun(@(x)10^x,res_temp);
    end

        
    C_I_CD8 = C_I_est;    
    p_m = param_est(1);
    p_s = param_est(2);
    g_l = param_est(3);

    g_ms = param_est(4);
    g_sl = param_est(5);

    function dy = equ(t,y)
      dy = zeros(2+1,1);
       dy(1) = (p_m*dend_cell(t-delay)-g_ms);
       dy(2) = (p_s*dend_cell(t-delay)-g_sl)+g_ms*exp(y(1)-y(2));
       dy(3) = g_sl*exp(y(2)-y(3))-g_l;
    end

    vecteur = time_obs(1):(time_obs(end) - time_obs(1))/200:time_obs(end);
    sol_ODE = ode45(@equ,vecteur,C_I_CD8);
    
    point_sim = deval(sol_ODE,time_obs);
    
    residu=0;
    for ni = 1 : length(time_obs)
        mat_obs = data_CD8{ni};
        point_sim_obs = point_sim(:,ni);
        
        if ~isempty(find(mat_obs(:,3)==-inf))
            indice = find(mat_obs(:,3)==-inf);
            mat_obs(indice,3) = point_sim_obs(3);
        end
        
        [nb_ligne nb_col] = size(mat_obs);
        %mat_obs
        point_sim_obs= point_sim_obs';
        %repmat(point_sim_obs,nb_ligne,1)
        residu = residu + sum(sum((mat_obs - repmat(point_sim_obs,nb_ligne,1)).^2));
    end
    
  
end