function [est_param_nls resnorm residual] = est_influenza_nls(param_ini,C_I_ini,data_CD8,time_obs)
    %data_C8 : cell_array de taille time_obs. Chaque cellules contient une
    %matrices de taille (nb_individu*3)

    function res = func_eco_nls(theta)
        
    C_I_CD8 = theta(6:8);    
    p_m = theta(1);
    p_s = theta(2);
    g_l = theta(3);

    g_ms = theta(4);
    g_sl = theta(5);

    function dy = equ(t,y)
      dy = zeros(2+1,1);
        dy(1) = (p_m*dend_cell(t-delay)-g_ms)*y(1);
        dy(2) = (p_s*dend_cell(t-delay)-g_sl)*y(2)+g_ms*y(1);
        dy(3) = g_sl*y(2) -g_l*y(3);

    end

    vecteur = time_obs(1):(time_obs(end) - time_obs(1))/200:time_obs(end);
    sol_ODE = ode45(@equ,vecteur,C_I_CD8);
    
    point_sim = deval(sol_ODE,time_obs);
    
    indice = 1;
    for ni = 1 : length(time_obs)
        mat_obs = data_CD8{ni};
        [nb_ligne nb_col] = size(mat_obs);
        point_sim_obs = point_sim(ni,:);
        res(indice:indice+nb_ligne-1,:)= mat_obs - repmat(point_sim_obs,nb_ligne);
        indice = indice+nb_ligne;
    end
    
    res_taille = size(res);
    res = reshape(res,res_taille(1)*res_taille(2),1);
    
  
    end

   param0 = [param_ini C_I_ini];
   opt=optimset('TolX',1e-10,'MaxIter',1e2,'TolFun',1e-10,'MaxFunEvals',1e4);
  [est_param_nls,resnorm,residual] = lsqnonlin(@ func_eco_nls,param0,[],[],opt);
   

end