
delay = 3.08

%moy_T_translog = moy_T_translog(2:end-1,:)
moy_logtransform_sp = moy_logtransform(3:end-1,:);
data_infl_regroupe_sp = data_infl_regroupe(3:end-1);

valeur_param_wu = [1.66*10^-5 4.47*10^-5 3.97 0.157 0.496];
CI_wu = [log(3960) log(3660) log(13100)]

%% dendritic cell estimation
Obs_dend = Observation(data_moy(:,1),data_moy(:,2));
bs_dend = bSplines(Obs_dend);
sample_dend = bs_dend.calcul_prediction(2:0.1:15);
sample_dend = arrayfun(@(x)10^x,sample_dend);
plot(2:0.1:15,sample_dend)

%% CD8+T cell estimation

Obs_T_infl = Observation(moy_logtransform_sp(:,1),moy_logtransform_sp(:,2:4));
bs_infl = bSplines(Obs_T_infl)
%bs_infl.erreur(1)

% set knots
knots_infl = bs_infl.getKnots()
nv_knots_infl = knots_infl;


% anc_knots_infl_1 =
% 
%      5    14
% 
% anc_knots_infl_2 =
% 
%      5    14
% 
% 
% anc_knots_infl_3 =
% 
%      5    14 
  
 knots_infl2_1 = [5 7.9 8.8 11 14];  
 knots_infl2_2 = [5 8.1 14];
 knots_infl2_3 = [5 9 10.1 14];

 nv_knots_infl{1} = knots_infl2_1
 nv_knots_infl{2} = knots_infl2_2
 nv_knots_infl{3} = knots_infl2_3

bs_infl.setKnots(nv_knots_infl)
bs_infl.erreur(1)

%% CD8+T cell Robust estimation

Obs_T_infl = Observation(moy_logtransform_sp(:,1),moy_logtransform_sp(:,2:4));
bs_infl = bSplines(Obs_T_infl)
%bs_infl.erreur(1)

% set knots
knots_infl = bs_infl.getKnots()
nv_knots_infl = knots_infl;


% anc_knots_infl_1 =
% 
%      5    14
% 
% anc_knots_infl_2 =
% 
%      5    14
% 
% 
% anc_knots_infl_3 =
% 
%      5    14 
  
 knots_infl2_1 = [5 7.9 8.8 11 14];  
 knots_infl2_2 = [5 8.1 14];
 knots_infl2_3 = [5 9 10.1 14];

 nv_knots_infl{1} = knots_infl2_1
 nv_knots_infl{2} = knots_infl2_2
 nv_knots_infl{3} = knots_infl2_3

bs_infl.setKnots(nv_knots_infl)
est_non_param_robust = bs_infl.calcul_prediction_robust(5:14)

plot(5:14,est_non_param_robust)
hold on
bs_infl.erreur(1)

%% Parametric estimation
anc_L = 4;
% 
%  Xl_infl = compute_xl_influenza(bs_infl,@splines_annulateur_borne,bs_dend,delay,anc_L)
%  Y1_infl = compute_yl_influenza(bs_infl,@splines_annulateur_borne,anc_L)
%  par_temp = -(inv(Xl_infl'*Xl_infl)*Xl_infl'*Y1_infl)'
 
 [res_est var_param_min intervalle_confiance] = minimize_variance_influenza(bs_infl,@splines_annulateur_borne,anc_L,bs_dend,3.08);
 %[res_est ] = minimize_variance_influenza_cut_off(bs_infl,@splines_annulateur_borne,anc_L,bs_dend,3.08)
 %[C_I val_func_eco] = estimation_C_I_influenza(bs_infl,res_est,bs_dend,delay)
 
 
 residu = calcul_residu_influenza(res_est,bs_infl.calcul_prediction(5),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)
 %param_est = est_nls_influenza(res_est,bs_infl.calcul_prediction(5),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)
 [beta COVB] = nls_curve_influenza(res_est,bs_infl.calcul_prediction(5),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)
 cs_nls = intervalle_confiance_nls(COVB,beta)

 residu = calcul_residu_influenza(beta(1:5),beta(6:8),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)
 
% anc_L = 4;
% 
%  Xl_infl = compute_xl_influenza(bs_infl,@splines_annulateur_borne,bs_dend,delay,anc_L)
%  Y1_infl = compute_yl_influenza(bs_infl,@splines_annulateur_borne,anc_L)
%  par_temp = -(inv(Xl_infl'*Xl_infl)*Xl_infl'*Y1_infl)'
%  
% [res_est var_param_min intervalle_confiance] = minimize_variance_influenza(bs_infl,@splines_annulateur_borne,anc_L,bs_dend,3.08);
 %[res_est ] = minimize_variance_influenza_cut_off(bs_infl,@splines_annulateur_borne,anc_L,bs_dend,3.08)
 %[C_I val_func_eco] = estimation_C_I_influenza(bs_infl,res_est,bs_dend,delay)
 
 
%residu = calcul_residu_influenza(res_est,bs_infl.calcul_prediction(5),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)
%param_est = est_nls_influenza(res_est,bs_infl.calcul_prediction(5),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)
%residu = calcul_residu_influenza(param_est(1:5),param_est(6:8),data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,delay)


%% PLot estimated curve

vect_Wu_update = [rho_m rho_s gamma_l sigma_m_s sigma_s_l];
CI_Wu_update = [log(T_E_M_5) log(T_E_S_5) log(T_E_L_5)];
T_obs = [5 6 7 8 9 10 11 12 14];


[res_oc1 t_plot] = log_influenza_sim(5,14,res_est_181,est_ci_181,bs_dend,delay)
[res_oc1_pt t_plot_pt] = log_influenza_sim(5,14,res_est_181,est_ci_181,bs_dend,delay,T_obs)


[res_oc2 t_plot] = log_influenza_sim(5,14,res_est_192,est_ci_192,bs_dend,delay)
[res_oc2_pt t_plot_pt] = log_influenza_sim(5,14,res_est_192,est_ci_192,bs_dend,delay,T_obs)

[res_nls_2cas t_plot_nls] = log_influenza_sim(5,14,res_nls(1:5),res_nls(6:8),bs_dend,delay)

res_nls_2cas = res_nls_2cas';
%hold on
%res_nls = log_influenza_sim(5,14,beta(1:5),beta(6:8),bs_dend,delay)

time_obs_dup = [5*ones(1,6) 6*ones(1,6) 7*ones(1,6) 8*ones(1,6) 9*ones(1,6) 10*ones(1,6) 11*ones(1,6) 12*ones(1,12) 14*ones(1,6)];
data_mat = cell2mat(data_infl_regroupe_sp);
plot(time_obs_dup',data_mat(:,1),'rx',time_obs_dup',data_mat(:,2),'gx',time_obs_dup',data_mat(:,3),'bx')
%hold on
%plot(t_plot,res_nls(:,1),'r',t_plot,res_nls(:,2),'g',t_plot,res_nls(:,3),'b')
hold on
plot(t_plot,res_oc1(:,1),'r--',t_plot,res_oc1(:,2),'g--',t_plot,res_oc1(:,3),'b--')
hold on
plot(T_obs,res_oc1_pt(1,:),'rs',T_obs,res_oc1_pt(2,:),'gs',T_obs,res_oc1_pt(3,:),'bs','MarkerSize',7)
hold on
plot(t_plot,res_oc2(:,1),'r--',t_plot,res_oc2(:,2),'g--',t_plot,res_oc2(:,3),'b--')
hold on
plot(T_obs,res_oc2_pt(1,:),'ro',T_obs,res_oc2_pt(2,:),'go',T_obs,res_oc2_pt(3,:),'bo','MarkerSize',7)

%hold on
plot(t_plot_nls,res_nls_2cas(1,:),'r',t_plot_nls,res_nls_2cas(2,:),'g',t_plot_nls,res_nls_2cas(3,:),'b')


%% PLot nls vs param Wu

T_E_M_5 = 3.96E+3;
T_E_S_5  =3.64E+4;
T_E_L_5 = 1.31E+3;

rho_m = 1.66E-5;
rho_s = 4.48E-5;

sigma_m_s = 1.57E-1;
sigma_s_l = 4.95E-1;

gamma_l = 3.96E+0; 

Tau = 3.08E+0;

vect_Wu_update = [rho_m rho_s gamma_l sigma_m_s sigma_s_l];
CI_Wu_update = [log(T_E_M_5) log(T_E_S_5) log(T_E_L_5)];
T_obs = [5 6 7 8 9 10 11 12 14];


[res_nls t_plot] = log_influenza_sim(5,14,beta(1:5),beta(6:8),bs_dend,delay)
[res_nls_pt t_plot_pt] = log_influenza_sim(5,14,beta(1:5),beta(6:8),bs_dend,delay,0,0,T_obs)

[res_wu t_plot_wu] = log_influenza_sim(5,14,vect_Wu_update,CI_Wu_update,bs_dend,delay)
[res_wu_pt t_plot_pt_wu] = log_influenza_sim(5,14,vect_Wu_update,CI_Wu_update,bs_dend,delay,0,0,T_obs)


%hold on
%res_nls = log_influenza_sim(5,14,beta(1:5),beta(6:8),bs_dend,delay)

time_obs_dup = [5*ones(1,6) 6*ones(1,6) 7*ones(1,6) 8*ones(1,6) 9*ones(1,6) 10*ones(1,6) 11*ones(1,6) 12*ones(1,12) 14*ones(1,6)];
data_mat = cell2mat(data_infl_regroupe_sp);
plot(time_obs_dup',data_mat(:,1),'rx',time_obs_dup',data_mat(:,2),'gx',time_obs_dup',data_mat(:,3),'bx')
%hold on
%plot(t_plot,res_nls(:,1),'r',t_plot,res_nls(:,2),'g',t_plot,res_nls(:,3),'b')
hold on
plot(t_plot,res_nls(:,1),'r--',t_plot,res_nls(:,2),'g--',t_plot,res_nls(:,3),'b--')
hold on
plot(T_obs,res_nls_pt(1,:),'rs',T_obs,res_nls_pt(2,:),'gs',T_obs,res_nls_pt(3,:),'bs','MarkerSize',7)
hold on
plot(t_plot,res_wu(:,1),'r--',t_plot,res_wu(:,2),'g--',t_plot,res_wu(:,3),'b--')
hold on
plot(T_obs,res_wu_pt(1,:),'ro',T_obs,res_wu_pt(2,:),'go',T_obs,res_wu_pt(3,:),'bo','MarkerSize',7)




%% Robustness test
anc_L = 4;
[res_est var_param_min intervalle_confiance] = minimize_variance_influenza(bs_infl,@splines_annulateur_borne,anc_L,bs_dend,3.08)
[res_oc t_plot] = log_influenza_sim(5,14,res_est,bs_infl.calcul_prediction(5),bs_dend,delay);

[res_oc_sample t_plot] = log_influenza_sim(5,14,res_est,bs_infl.calcul_prediction(5),bs_dend,delay,[5 6 7 8 9 10 11 12 14]);

nb_test = 100;
niveau_bruit = 5;
matrice_ecart = zeros(100,5);

for nj = 1 : niveau_bruit
    for ni = 1  : nb_test


        
sample_bruite = res_oc_sample' + niveau_bruit*0.1*randn(9,3);
Obs_T_infl = Observation(moy_logtransform_sp(:,1),sample_bruite);
bs_infl = bSplines(Obs_T_infl);

% set knots
knots_infl = bs_infl.getKnots();
nv_knots_infl = knots_infl;

 knots_infl2_1 = [5 7.9 8.8 11 14];  
 knots_infl2_2 = [5 8.1 14];
 knots_infl2_3 = [5 9 10.1 14];
 
 nv_knots_infl{1} = knots_infl2_1;
 nv_knots_infl{2} = knots_infl2_2;
 nv_knots_infl{3} = knots_infl2_3;

bs_infl.setKnots(nv_knots_infl);
%bs_infl.erreur(1)
[nv_est var_param_min intervalle_confiance] = minimize_variance_influenza(bs_infl,@splines_annulateur_borne,anc_L,bs_dend,3.08)

ecart = sum(((res_est - nv_est)./res_est).^2)
matrice_ecart(ni,nj) = ecart;

    end
end



%% WU et al value

T_E_M_5 = 3.96E+3;
T_E_S_5  =3.64E+4;
T_E_L_5 = 1.31E+3;

rho_m = 1.66E-5;
rho_s = 4.48E-5;

sigma_m_s = 1.57E-1;
sigma_s_l = 4.95E-1;

gamma_l = 3.96E+0; 

Tau = 3.08E+0;

vect_Wu_update = [rho_m rho_s gamma_l sigma_m_s sigma_s_l];

residu = calcul_residu_influenza(vect_Wu_update,[log(T_E_M_5) log(T_E_S_5) log(T_E_L_5)],data_infl_regroupe_sp,[5 6 7 8 9 10 11 12 14],bs_dend,Tau)


% residu =
% 
%   137.1848


