function r = der_vect_param_influenza_gs(t,fd_cell,p,param_time,func_dend)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fhndfdp
% The derivative of the FitzHugh Nagumo equations with respect to p
% at times t with parameters p. 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

vx = eval_fdcell(t,fd_cell,0);
r = cell(3,5);
r(1:3,1:7) = {0};

    log_p_m = p(1);
    log_p_s = p(2);
    
    log_g_l = p(3);

    log_g_ms = p(4);
    log_g_sl = p(5);

    p_m = exp(log_p_m);
    p_s = exp(log_p_s);
    
    g_l = exp(log_g_l);

    g_ms = exp(log_g_ms);
    g_sl = exp(log_g_sl);  
    
    delay = param_time(1);
    time_shift = param_time(2);
    
    r{1,1} = p_m*func_dend(t+time_shift-delay);
    r{1,4} = -g_ms;
    
    r{2,2} = p_s*func_dend(t+time_shift-delay);   
    r{2,4} = g_ms*exp(vx{1}-vx{2});
    r{2,5} = -g_sl;
    
    r{3,3} = -g_l;
    r{3,5} = g_sl*exp(vx{2}-vx{3});
end