function r = influenza_fun_gs(t,fd_cell,p,param_time,func_dend,knots)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% fhnfun
%
% The FitzHugh-Nagumo equations in vector form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

y = eval_fdcell(t,fd_cell,0);
r = y;

    log_p_m = p(1);
    log_p_s = p(2);

    log_g_ms = p(3);
    log_g_sl = p(4);
    
    param_beta = reshape(p(5:end),length(p(5:end)),1);
    
    
    p_m = exp(log_p_m);
    p_s = exp(log_p_s);

    g_ms = exp(log_g_ms);
    g_sl = exp(log_g_sl);
        
    
    delay = param_time(1);
    time_shift = param_time(2);
        
    r{1} =  (p_m*func_dend(t+time_shift-delay)-g_ms);
    r{2} =  (p_s*func_dend(t+time_shift-delay)-g_sl)+g_ms*exp(y{1}-y{2});
    r{3} =  g_sl*exp(y{2}-y{3}) -(bsplineM(t,knots,4,0,0)*param_beta);

end