
%% data recuperation
clear
load('ensemble_donne_utile.mat')
% mln, spleen and lung logtrainsformed data


%moy_T_translog = moy_T_translog(2:end-1,:)
moy_logtransform_sp = moy_logtransform(3:end-1,:);
data_infl_regroupe_sp = data_infl_regroupe(3:end-1);


 
% dendritic cell estimation
Obs_dend = Observation(data_moy(:,1),data_moy(:,2));
bs_dend = bSplines(Obs_dend);

func_inter_dend  = @(t)(bs_dend.calcul_prediction(t,0));
sample_dend = bs_dend.calcul_prediction(2:0.1:15);
sample_dend = arrayfun(@(x)10^x,sample_dend);
plot(2:0.1:15,sample_dend)

estimation_interval = [5 6 7 8 9 10 11 12 14];


%% Non parametric estimator &  CD8+T cell estimation

rho_m = 1.15E-5;
rho_s = 2.72E-5;

sigma_m_s = 1.58E-1;
sigma_s_l = 2.50E-1;

Tau = 3.53E+0;

vect_Wu_function = [rho_m rho_s  sigma_m_s sigma_s_l];
log_vect_Wu_function = log(vect_Wu_function);

CI_Wu_3rdcase = [log(4430) log(3490) log(1330)];

shift = 5;
Obs_T_infl = Observation(moy_logtransform_sp(:,1)-shift,moy_logtransform_sp(:,2:4));

bs_infl1 = bSplines(Obs_T_infl);
bs_infl2 = bSplines(Obs_T_infl);

bs_infl_known_ci1 = bSplines(Obs_T_infl,3,CI_Wu_3rdcase);
bs_infl_known_ci2 = bSplines(Obs_T_infl,3,CI_Wu_3rdcase);
%bs_infl.erreur(1)

% set knots
knots_infl = bs_infl1.getKnots();
nv_knots_infl = knots_infl;


 knots_infl2_1 = [5 7.9 8.8 11 14]-shift;  
 knots_infl2_2 = [5 8.1 14]-shift;
 knots_infl2_3 = [5 9 10.1 14]-shift;

 nv_knots_infl{1} = knots_infl2_1
 nv_knots_infl{2} = knots_infl2_2
 nv_knots_infl{3} = knots_infl2_3

bs_infl1.setKnots(nv_knots_infl)
bs_infl1.erreur(1)

% figure
 bs_infl_known_ci1.setKnots(nv_knots_infl,CI_Wu_3rdcase)
% bs_infl_known_ci1.erreur(1)
% 
% figure
% bs_infl_known_ci2.erreur(1)
% 
% figure
% bs_infl2.erreur(1)

%%

mat_C_ext = zeros(3,5);
mat_C_ext(1:3,1:3) = eye(3);

mat_B_ext = zeros(5,4);
mat_B_ext(1:3,1:3) = eye(3);
mat_B_ext(5,4) = 1;

lambda_trial = [1000 10000 100000];
lambda1_trial = [1 5];
log_param_ini =  [log_vect_Wu_function 0 0];

mat_est_infl1 = zeros(length(lambda_trial),6,length(lambda1_trial));
mat_est_infl2 = zeros(length(lambda_trial),6,length(lambda1_trial));

mat_est_infl1_known_ci = zeros(length(lambda_trial),6,length(lambda1_trial));
mat_est_infl2_known_ci = zeros(length(lambda_trial),6,length(lambda1_trial));

mat_errpred2_infl1 = zeros(length(lambda_trial),length(lambda1_trial));
mat_errpred2_infl2 = zeros(length(lambda_trial),length(lambda1_trial));

mat_errpred2_infl1_known_ci = zeros(length(lambda_trial),length(lambda1_trial));
mat_errpred2_infl2_known_ci = zeros(length(lambda_trial),length(lambda1_trial));


%    save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci',...
%         'mat_errpred2_infl1','mat_errpred2_infl2','mat_errpred2_infl1_known_ci','mat_errpred2_infl2_known_ci');
    
    T_st = Obs_T_infl.time_obs{1};
    intervalle_int2 = zeros(2,2);
    intervalle_int2(1,:) = [T_st(1) T_st(5)];
    intervalle_int2(2,:) = [T_st(5) T_st(9)];


    v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    
   for nl = 1 : length(lambda_trial)
       
       for nl1 = 1 : length(lambda1_trial)

          mat_U = zeros(4);
          mat_U(1:3,1:3) = lambda_trial(nl)*eye(3);
          mat_U(4,4) = lambda1_trial(nl1);

       % try
        [est_param_oca_infl1,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,log_param_ini,CI_Wu_3rdcase,mat_B_ext);  
         
         est_param_oca_infl1_cur =  est_param_oca_infl1(1:4);
         est_vect_CI_infl1_ext = [CI_Wu_3rdcase est_param_oca_infl1(5:6)];

         bs_u_infl1 = est_control_pontryagin(bs_infl1,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_infl1_cur,est_vect_CI_infl1_ext,mat_B_ext);
         sol_Xu_infl1 = pontryagin_compute_controlled_solution(bs_u_infl1,v_field,est_param_oca_infl1_cur,est_vect_CI_infl1_ext,mat_B_ext);
         Obs_infl1 = bs_infl1.getObservation();
         Tu_infl1 = Obs_infl1.getTimes();
         sol_Xu_infl1_T1 = deval(sol_Xu_infl1,Tu_infl1{1});

         bs_gl_infl1 = bSplines(Observation(Tu_infl1{1},sol_Xu_infl1_T1(4,:)'));
         v_field_gl_infl1 = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau shift],@(t)(10^func_inter_dend(t)),bs_gl_infl1);


         res_err_pred2_infl1 = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_infl1,bs_u_infl1,v_field,v_field_gl_infl1,eye(3),est_param_oca_infl1_cur,est_vect_CI_infl1_ext,intervalle_int2,mat_B_ext);
         
         
         
         mat_errpred2_infl1(nl,nl1) = res_err_pred2_infl1;
         mat_est_infl1(nl,:,nl1) = est_param_oca_infl1; 
         
            save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci',...
        'mat_errpred2_infl1','mat_errpred2_infl2','mat_errpred2_infl1_known_ci','mat_errpred2_infl2_known_ci');
         
%         catch     
%             'echec infl1' 
%             nl
%         end
        
       try
        [est_param_oca_infl2,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,log_param_ini,CI_Wu_3rdcase,mat_B_ext);  
         
         est_param_oca_infl2_cur =  est_param_oca_infl2(1:4);
         est_vect_CI_infl2_ext = [CI_Wu_3rdcase est_param_oca_infl2(5:6)];

         bs_u_infl2 = est_control_pontryagin(bs_infl2,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_infl2_cur,est_vect_CI_infl2_ext,mat_B_ext);
         sol_Xu_infl2 = pontryagin_compute_controlled_solution(bs_u_infl2,v_field,est_param_oca_infl2_cur,est_vect_CI_infl2_ext,mat_B_ext);
         Obs_infl2 = bs_infl2.getObservation();
         Tu_infl2 = Obs_infl2.getTimes();
         sol_Xu_infl2_T1 = deval(sol_Xu_infl2,Tu_infl2{1});

         bs_gl_infl2 = bSplines(Observation(Tu_infl2{1},sol_Xu_infl2_T1(4,:)'));
         v_field_gl_infl2 = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau shift],@(t)(10^func_inter_dend(t)),bs_gl_infl2);


         res_err_pred2_infl2 = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_infl2,bs_u_infl2,v_field,v_field_gl_infl2,eye(3),est_param_oca_infl2_cur,est_vect_CI_infl2_ext,intervalle_int2,mat_B_ext);
         
         mat_errpred2_infl2(nl,nl1) = res_err_pred2_infl2;
         mat_est_infl2(nl,:,nl1) = est_param_oca_infl2; 
         
            save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci',...
        'mat_errpred2_infl1','mat_errpred2_infl2','mat_errpred2_infl1_known_ci','mat_errpred2_infl2_known_ci');
         
        catch     
            'echec infl2' 
            nl
       end    
        
        
        try
        [est_param_oca_infl1_knci,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl_known_ci1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,log_param_ini,CI_Wu_3rdcase,mat_B_ext);  
         
         est_param_oca_infl1_knci_cur =  est_param_oca_infl1_knci(1:4);
         est_vect_CI_infl1_knci_ext = [CI_Wu_3rdcase est_param_oca_infl1_knci(5:6)];

         bs_u_infl1_knci = est_control_pontryagin(bs_infl_known_ci1,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_infl1_knci_cur,est_vect_CI_infl1_knci_ext,mat_B_ext);
         sol_Xu_infl1_knci = pontryagin_compute_controlled_solution(bs_infl_known_ci1,v_field,est_param_oca_infl1_knci_cur,est_vect_CI_infl1_knci_ext,mat_B_ext);
         Obs_infl1_knci = bs_u_infl1_knci.getObservation();
         Tu_infl1_knci = Obs_infl1_knci.getTimes();
         sol_Xu_infl1_knci_T1 = deval(sol_Xu_infl1_knci,Tu_infl1_knci{1});

         bs_gl_infl1_knci = bSplines(Observation(Tu_infl1_knci{1},sol_Xu_infl1_knci_T1(4,:)'));
         v_field_gl_infl1_knci = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau shift],@(t)(10^func_inter_dend(t)),bs_gl_infl1_knci);


         res_err_pred2_infl1_knci = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_infl_known_ci1,bs_u_infl1_knci,v_field,v_field_gl_infl1_knci,eye(3),est_param_oca_infl1_knci_cur,est_vect_CI_infl1_knci_ext,intervalle_int2,mat_B_ext);
         
         
         
         mat_errpred2_infl1_known_ci(nl,nl1) = res_err_pred2_infl1_knci;
         mat_est_infl1_known_ci(nl,:,nl1) = est_param_oca_infl1_knci; 
         
         
            save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci',...
        'mat_errpred2_infl1','mat_errpred2_infl2','mat_errpred2_infl1_known_ci','mat_errpred2_infl2_known_ci');
         
        catch     
            'echec infl1 known ci' 
            nl
        end
        
         try
        [est_param_oca_infl2_knci,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl_known_ci2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,log_param_ini,CI_Wu_3rdcase,mat_B_ext);  
         
         est_param_oca_infl2_knci_cur =  est_param_oca_infl2_knci(1:4);
         est_vect_CI_infl2_knci_ext = [CI_Wu_3rdcase est_param_oca_infl2_knci(5:6)];

         bs_u_infl2_knci = est_control_pontryagin(bs_infl_known_ci2,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_infl2_knci_cur,est_vect_CI_infl2_knci_ext,mat_B_ext);
         sol_Xu_infl2_knci = pontryagin_compute_controlled_solution(bs_infl_known_ci2,v_field,est_param_oca_infl2_knci_cur,est_vect_CI_infl2_knci_ext,mat_B_ext);
         Obs_infl2_knci = bs_u_infl2_knci.getObservation();
         Tu_infl2_knci = Obs_infl2_knci.getTimes();
         sol_Xu_infl2_knci_T1 = deval(sol_Xu_infl2_knci,Tu_infl2_knci{1});

         bs_gl_infl2_knci = bSplines(Observation(Tu_infl2_knci{1},sol_Xu_infl2_knci_T1(4,:)'));
         v_field_gl_infl2_knci = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau shift],@(t)(10^func_inter_dend(t)),bs_gl_infl2_knci);


         res_err_pred2_infl2_knci = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_infl_known_ci2,bs_u_infl2_knci,v_field,v_field_gl_infl2_knci,eye(3),est_param_oca_infl2_knci_cur,est_vect_CI_infl2_knci_ext,intervalle_int2,mat_B_ext);
         
         
         
         mat_errpred2_infl2_known_ci(nl,nl1) = res_err_pred2_infl2_knci;
         mat_est_infl2_known_ci(nl,:,nl1) = est_param_oca_infl2_knci; 
         
            save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci',...
        'mat_errpred2_infl1','mat_errpred2_infl2','mat_errpred2_infl1_known_ci','mat_errpred2_infl2_known_ci');
         
        catch     
            'echec infl2 known ci' 
            nl
        end
        
        
       end
   end 

    
   
   %%

mat_C_ext = zeros(3,5);
mat_C_ext(1:3,1:3) = eye(3);

mat_B_ext = zeros(5,4);
mat_B_ext(1:3,1:3) = eye(3);
mat_B_ext(5,4) = 1;

lambda_trial = [1 10 100 1000 10000 100000];
lambda1_trial = [0.1 0.5 1 5];
log_param_ini =  [log_vect_Wu_function 0 0];

param_ini_infl1 = log_param_ini;
param_ini_infl2 = log_param_ini;
param_ini_infl1_knci = log_param_ini;
param_ini_infl2_knci = log_param_ini;

mat_est_infl1 = zeros(length(lambda_trial),6,length(lambda1_trial));
mat_est_infl2 = zeros(length(lambda_trial),6,length(lambda1_trial));

mat_est_infl1_known_ci = zeros(length(lambda_trial),6,length(lambda1_trial));
mat_est_infl2_known_ci = zeros(length(lambda_trial),6,length(lambda1_trial));


%   save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci');
    
    T_st = Obs_T_infl.time_obs{1};
    intervalle_int2 = zeros(2,2);
    intervalle_int2(1,:) = [T_st(1) T_st(5)];
    intervalle_int2(2,:) = [T_st(5) T_st(9)];


    v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau shift],@(t)(10^func_inter_dend(t)));
    
   for nl = 1 : length(lambda_trial)
       
       for nl1 = 1 : length(lambda1_trial)

          mat_U = zeros(4);
          mat_U(1:3,1:3) = lambda_trial(nl)*eye(3);
          mat_U(4,4) = lambda1_trial(nl1);

          mat_U
       try
        [est_param_oca_infl1,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,param_ini_infl1,CI_Wu_3rdcase,mat_B_ext);      
        
        param_ini_infl1 = est_param_oca_infl1;
        mat_est_infl1(nl,:,nl1) = est_param_oca_infl1;
        catch     
            'echec infl1' 
            nl
       end
        
        
       try
        [est_param_oca_infl2,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,param_ini_infl2,CI_Wu_3rdcase,mat_B_ext);  
        
        param_ini_infl2 = est_param_oca_infl2;
        mat_est_infl2(nl,:,nl1) = est_param_oca_infl2;
 
       catch     
            'echec infl2' 
            nl
       end    
        
        
        try
        [est_param_oca_infl1_knci,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl_known_ci1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,param_ini_infl1_knci,CI_Wu_3rdcase,mat_B_ext);      
               
        param_ini_infl1_knci = est_param_oca_infl1_knci;
               
        mat_est_infl1_known_ci(nl,:,nl1) = param_ini_infl1_knci;
        
        catch     
            'echec infl1 known ci' 
            nl
        end
        
         try
        [est_param_oca_infl2_knci,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_infl_known_ci2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,param_ini_infl2_knci,CI_Wu_3rdcase,mat_B_ext);  
        
        param_ini_infl2_knci = est_param_oca_infl2_knci;
        mat_est_infl2_known_ci(nl,:,nl1) = param_ini_infl2_knci;
        catch     
            'echec infl2 known ci' 
            nl
         end
        
   save('new_est_real_data_case_influenza','mat_est_infl1','mat_est_infl2','mat_est_infl1_known_ci','mat_est_infl2_known_ci');
       end
   end 
    
   
   
   %% Exploitation res 
   
% lambda =  100000   
%    est_infl1(1)
% 
% ans =
% 
%    1.8022e-05
% 
% est_infl1(2)
% 
% ans =
% 
%    5.9577e-05
% 
% est_infl1(3)
% 
% ans =
% 
%     0.2336
% 
% est_infl1(4)
% 
% ans =
% 
%     0.5097
% 
% est_infl2 =
% 
%     0.0000    0.0001    0.2535    0.4163
% 
% est_infl2(1)
% 
% ans =
% 
%    1.8486e-05
% 
% est_infl2(2)
% 
% ans =
% 
%    5.5051e-05

mat_est_cur =  mat_est_infl2;
bs_cur = bs_infl2;

T_st = Obs_T_infl.time_obs{1};
intervalle_int2 = zeros(2,2);
intervalle_int2(1,:) = [T_st(1) T_st(5)];
intervalle_int2(2,:) = [T_st(5) T_st(9)];
mat_errpred2 = zeros(length(lambda_trial), length(lambda1_trial));

  
   for nl = 1 : length(lambda_trial)
       
       for nl1 = 1 : length(lambda1_trial)

          mat_U = zeros(4);
          mat_U(1:3,1:3) = lambda_trial(nl)*eye(3);
          mat_U(4,4) = lambda1_trial(nl1);

       % try
         est_param_oca = mat_est_cur(nl,:,nl1)  
         
         est_param_oca_cur =  est_param_oca(1:4);
         est_vect_CI_ext = [CI_Wu_3rdcase 0 est_param_oca(6)];

         bs_u = est_control_pontryagin(bs_cur,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_cur,est_vect_CI_ext,mat_B_ext);
         sol_Xu = pontryagin_compute_controlled_solution(bs_u,v_field,est_param_oca_cur,est_vect_CI_ext,mat_B_ext);
         Obs_cur = bs_u.getObservation();
         Tu_cur = Obs_cur.getTimes();
         sol_Xu_T1 = deval(sol_Xu,Tu_cur{1});

         bs_gl = bSplines(Observation(Tu_cur{1},sol_Xu_T1(4,:)'));
         v_field_gl = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau shift],@(t)(10^func_inter_dend(t)),bs_gl);


         res_err_pred2 = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_cur,bs_u,v_field,v_field_gl,eye(3),est_param_oca_cur,est_vect_CI_ext,intervalle_int2,mat_B_ext);
               
        
         mat_errpred2(nl,nl1) = res_err_pred2;
        
         bs_gl_T1 = bs_gl.calcul_prediction(Tu_cur{1},0);
         
         figure
         plot(Tu_cur{1},bs_gl_T1)
         title(sprintf('graphe_%d_%d',nl,nl1))

       end
   end 

%% estimation in misspecified case
T_E_M_5 = 3.96E+3;
T_E_S_5  =3.64E+4;
T_E_L_5 = 1.31E+3;

rho_m = 1.66E-5;
rho_s = 4.48E-5;

sigma_m_s = 1.57E-1;
sigma_s_l = 4.95E-1;

gamma_l = 3.96E+0; 

Tau = 3.08E+0;

gamma_l_function = @(t)(t+sin(pi*t/9));

deb_sf = 0;
fin_sf = 9;
sf = 5;

dim_syst = 5;
mat_obs_c = zeros(3,5);
mat_obs_c(1:3,1:3) = eye(3);
mat_obs_c_nls = eye(3);

trial_exp = [-4 -2 -1 0 (log(5)/log(10)) 1 (log(50)/log(10)) 2];
lambda_trial = cell(1,length(trial_exp));
for nl = 1 : length(trial_exp)
    lambda_trial_cur = zeros(5,5);
    lambda_trial_cur(1:3,1:3) = 10^(trial_exp(nl))*eye(3);
    lambda_trial_cur(4,4) = 0.1;
    lambda_trial_cur(5,5) = 0.1;
    
    lambda_trial{nl}  = lambda_trial_cur;
end


vect_Wu_function = [rho_m rho_s  sigma_m_s sigma_s_l];
log_vect_Wu_function = [log(vect_Wu_function(1)) log(vect_Wu_function(2)) log(vect_Wu_function(3)) log(vect_Wu_function(4))];

CI_Wu = [log(T_E_M_5) log(T_E_S_5) log(T_E_L_5)];

% nb_coeff = 3;
% std_dyn = 0.15;
% vect_k_pi = pi*(1:1:nb_coeff);
% basis_fun_t = @(t)(fonc_base_kar(t,vect_k_pi,deb_sf,fin_sf));
% 
% res_c_1 = zeros(1,nb_coeff)+std_dyn*randn(nb_coeff,1)';
% res_c_2 = zeros(1,nb_coeff)+std_dyn*randn(nb_coeff,1)';  
% res_c_3 = zeros(1,nb_coeff)+std_dyn*randn(nb_coeff,1)';  

%forcing_function = @(t)([res_c_1*basis_fun_t(t) res_c_2*basis_fun_t(t) res_c_3*basis_fun_t(t)]');

nu_s_function = @(t)( (1/300)*t^2+(1/300)*t);
forcing_function = @(t)([0 t/50 0]');

val_miss_fun = arrayfun(forcing_function,deb_sf:((fin_sf-deb_sf)/100):fin_sf,'UniformOutput',false);
val_miss_fun = cell2mat(val_miss_fun)';
    
[Y1_pert T1_pert] = log_influenza_sim(deb_sf,50,fin_sf,vect_Wu_function,CI_Wu,bs_dend,Tau,0,sf,gamma_l_function,forcing_function);
[Y1 T1] = log_influenza_sim(deb_sf,100,fin_sf,vect_Wu_function,CI_Wu,bs_dend,Tau,0.1,sf,gamma_l_function);

% % 
 plot(T1_pert,Y1_pert,'r',T1,Y1,'g')
% figure
 plot(T1,val_miss_fun)
% 
%%
  Obs_l = Observation(T1_pert,Y1_pert); 
  bs_l = bSplines(Obs_l);


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


v_field_nls =  @(t,vx,param,param_fixe)vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)))
der_v_field_nls = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta_nls = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));



intervalle_test = deb_sf:0.045:fin_sf;
gamma_l_T = arrayfun(gamma_l_function,intervalle_test);
fonc_nls_gamma_l = @(vect_beta,t)(vect_beta*bsplineM(t+sf,[deb_sf+sf fin_sf+sf],3,0,0)');
func_min_gamma = @(vect_beta)(sum((fonc_nls_gamma_l(vect_beta,intervalle_test) -gamma_l_T).^2));
[val_est_beta val_res] = fminunc(func_min_gamma,[1 1 1]);
theta_ini_nls = [log(vect_Wu_function(1)) log(vect_Wu_function(2)) log(vect_Wu_function(3)) log(vect_Wu_function(4)) val_est_beta];

param_nls = est_param_nls_gradient_descent(Obs_l,v_field_nls,der_v_field_nls,der_v_field_theta_nls,3,[1 2 3],[theta_ini_nls CI_Wu],[],1)


    [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,[log_vect_Wu_function CI_Wu 0 2/9],[],2);

     bs_u_data = est_control_pontryagin(bs_l,v_field,der_v_field,mat_obs_c,cell2mat(lambda_opt_data),est_param_opt_data(1:4),est_param_opt_data(5:9));

     vect_param_reconstitue_data = arrayfun(@(x)(exp(x)),est_param_opt_data(1:4));
     ci_data= est_param_opt_data(5:9);
% 
%      [Times_est res_x sol_ode_u res_err_state_data res_err_state_data_wu res_err_pred_data res_err_pred_wu_data erreur_gl_data] = ...
%      reconstruction_influenza_control(deb_sf:0.09:fin_sf,vect_param_reconstitue_data,ci_data,vect_Wu_function,CI_Wu,[Tau sf],@(t)(10^func_inter_dend(t)),@(t)(bs_u_data.calcul_prediction(t,0)'),gamma_l_function,std);
%     
%      erreur_gl_data = erreur_gl_data./norme_gl
%    

%%
T_sim = 0:0.09:9;
val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

  bs_u_data = est_control_pontryagin(bs_l,v_field,der_v_field,mat_obs_c,cell2mat(lambda_opt_data),est_param_opt_data(1:4),est_param_opt_data(5:9));
     vect_param_reconstitue_data = arrayfun(@(x)(exp(x)),est_param_opt_data(1:4));
     ci_data= est_param_opt_data(5:9);
[Times_est res_x sol_ode_u state_rec_l2err state_rec_l2err_wu res_err_pred res_err_pred_wu erreur_gl] =  reconstruction_influenza_control(T_sim,vect_param_reconstitue_data,ci_data,vect_Wu_function,CI_Wu,[Tau sf],@(t)(10^func_inter_dend(t)),@(t)(bs_u_data.calcul_prediction(t,0)'),gamma_l_function,0.1,forcing_function)

erreur_gl = erreur_gl./norme_gl
erreur_param_data = sum(abs((est_param_opt_data(1:4)-log_vect_Wu_function)./log_vect_Wu_function))

% plot(T_sim,calcul_control(:,1),'rx',T_sim,calcul_control(:,2),'b--',T_sim,calcul_control(:,3),'go')
% figure
plot(T_sim,res_x(4,:),T_sim,val_gamma_l_function)
%%
trial_exp = [-2 -1 0 (log(5)/log(10)) 1 (log(50)/log(10)) 2 3];
lambda_trial = cell(1,length(trial_exp));
for nl = 1 : length(trial_exp)
    lambda_trial_cur = zeros(5,5);
    lambda_trial_cur(1:3,1:3) = 10^(trial_exp(nl))*eye(3);
    lambda_trial_cur(4,4) = 0.05;
    lambda_trial_cur(5,5) = 0.05;
    
    lambda_trial{nl}  = lambda_trial_cur;
end


    [est_param_opt_non_param,fval_opt_non_param,lambda_opt_non_param,est_param_opt_data,fval_opt_data,lambda_opt_data, mat_est, mat_fval,est_param_opt_non_param_cor,fval_opt_non_param_cor,lambda_opt_non_param_cor,est_param_opt_data_cor,fval_opt_data_cor,lambda_opt_data_cor]...
    = est_param_pontryagin_lambda_trial(bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,lambda_trial,[log_vect_Wu_function CI_Wu 0 2/9],[],2);

     bs_u_data = est_control_pontryagin(bs_l,v_field,der_v_field,mat_obs_c,cell2mat(lambda_opt_data),est_param_opt_data(1:4),est_param_opt_data(5:9));

     vect_param_reconstitue_data = arrayfun(@(x)(exp(x)),est_param_opt_data(1:4));
     ci_data= est_param_opt_data(5:9);

%%
   bs_u_nls = est_control_nls(bs_l,v_field_nls,mat_obs_c_nls,param_nls(1:7));
   [err_pred_nls err_state_nls] = compute_prediction_error_pontryagin(param_nls(1:7),theta_ini_nls ,400,deb_sf,fin_sf,CI_Wu,param_nls(8:10),mat_obs_c_nls,v_field_nls,0.1,[],forcing_function)
     [err_pred_nls_wu err_state_nls_wu] = compute_prediction_error_pontryagin(param_nls(1:7),theta_ini_nls ,400,deb_sf,fin_sf,CI_Wu,param_nls(8:10),mat_obs_c_nls,v_field_nls,0.1,@(t)(bs_u_nls.calcul_prediction(t,0)),forcing_function)
 
     erreur_param_nls = sum(abs((param_nls(1:4)-log_vect_Wu_function)./log_vect_Wu_function))

     est_nls_gamma_l = @(t)fonc_nls_gamma_l(param_nls(5:7),t);
     erreur_gl_nls = sqrt(quadv(@(t)((gamma_l_function(t)-est_nls_gamma_l(t)).^2),deb_sf,fin_sf))./norme_gl
       
%% ode sim shifted and GA estimation all time fixed parameters
deb_sf = 0;
fin_sf = 9;
pas = 100;
sf = 5;

std_sf = 0;
[res_y_sim_sf res_t_sim_sf] = log_influenza_sim(deb_sf,pas,fin_sf,vect_Wu,CI_Wu,bs_dend,Tau,std_sf,sf)

func_inter_dend  = @(t)(bs_dend.calcul_prediction(t,0));
Obs_sim_sf = Observation(res_t_sim_sf,res_y_sim_sf);
bs_sim_sf = bSplines(Obs_sim_sf);

%bs_sim_sf.erreur(1);

log_vect_Wu = arrayfun(@(x)log(x),vect_Wu);

v_field_gs = @(t,fd_cell,p)influenza_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_gs = @(t,fd_cell,p)der_vect_influenza_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_theta_gs = @(t,fd_cell,p)der_vect_param_influenza_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_state_theta_gs = @(t,fd_cell,p)der_sec_vect_param_influenza_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_state_state_gs = @(t,fd_cell,p)der_sec_vect_influenza_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));


      Tcell = cell(1,3);
      Tcell{1} = res_t_sim_sf(:,1);
      Tcell{2} = res_t_sim_sf(:,1);
      Tcell{3} = res_t_sim_sf(:,1);

      Ycell = cell(1,3);
      Ycell{1} = res_y_sim_sf(:,1);
      Ycell{2} = res_y_sim_sf(:,2);      
      Ycell{3} = res_y_sim_sf(:,3);
      
     [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,1.5*log_vect_Wu,v_field_gs, der_v_field_gs, der_v_field_theta_gs, der_v_field_state_state_gs, der_v_field_state_theta_gs);

%% ode sim shifted



Obs_sim_fun_sf = Observation(res_t_sim_fun_sf,res_y_sim_fun_sf);
bs_sim_fun_sf = bSplines(Obs_sim_fun_sf);

% bs_sim_sf.erreur(1);
% hold on
bs_sim_fun_sf.erreur(1);


%% estimate finite basis decomposition
Tau_3rdcase = 3.53;
sf_3rdcase = 5;
intervalle_test = deb_sf:0.045:fin_sf;
gamma_l_T = arrayfun(gamma_l_function,intervalle_test);
%plot(intervalle_test,gamma_l_T)
fonc_nls_gamma_l = @(vect_beta,t)(vect_beta*bsplineM(t+sf,[deb_sf+sf fin_sf+sf],3,0,0)');

func_min_gamma = @(vect_beta)(sum((fonc_nls_gamma_l(vect_beta,intervalle_test) -gamma_l_T).^2));

[val_est_beta val_res] = fminunc(func_min_gamma,[1 1 1])

est_nls_gamma_l_T_dir = fonc_nls_gamma_l(val_est_beta,intervalle_test);
plot(intervalle_test,gamma_l_T,'r',intervalle_test,est_nls_gamma_l_T_dir,'b')

ci_log_nls = CI_Wu;
log_param_ini_nls =  [log(vect_Wu_function(1)) log(vect_Wu_function(2)) log(vect_Wu_function(3)) log(vect_Wu_function(4)) val_est_beta]


[res_y_sim_fun_sf res_t_sim_fun_sf] = log_influenza_sim(deb_sf,pas,fin_sf,vect_Wu_function,CI_Wu,bs_dend,Tau,std_sf,sf,gamma_l_function)


Obs_sim_fun_sf = Observation(res_t_sim_fun_sf,res_y_sim_fun_sf);
bs_sim_fun_sf = bSplines(Obs_sim_fun_sf);

bs_sim_fun_sf.erreur(1);

figure
[res_y_sim_fun_sf res_t_sim_fun_sf] = log_influenza_sim(deb_sf,pas,fin_sf,vect_Wu_function,CI_Wu,bs_dend,Tau,std_sf,sf,@(t)(fonc_nls_gamma_l(val_est_beta,t)))

Obs_sim_fun_sf = Observation(res_t_sim_fun_sf,res_y_sim_fun_sf);
bs_sim_fun_sf = bSplines(Obs_sim_fun_sf);

bs_sim_fun_sf.erreur(1);
%%

v_field_nls =  @(t,vx,param,param_fixe)vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)))
der_v_field_nls = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta_nls = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));

[param_nls, fval] = est_param_nls_gradient_descent(Obs_sim_fun_sf,v_field_nls,der_v_field_nls,der_v_field_theta_nls,3,[1 2 3],log_param_ini_nls,ci_log_nls,1)

[param_nls_dc, fval_dc] = est_param_nls_gradient_descent(Obs_sim_fun_sf,v_field_nls,der_v_field_nls,der_v_field_theta_nls,3,[1 2 3],1.5*log_param_ini_nls,ci_log_nls,1)


% [param_nls_gf, fval_gf] = est_param_nls_gradient_descent(Obs_sim_fun_sf,v_field_nls,[],[],3,[1 2 3],log_param_ini_nls,ci_log_nls,1)
% 
% [param_nls_gf_dc, fval_gf_dc] = est_param_nls_gradient_descent(Obs_sim_fun_sf,v_field_nls,[],[],3,[1 2 3],1.5*log_param_ini_nls,ci_log_nls,1)
% 

%%

coeff_b = (9.5-28/5)/(14*4);
coeff_a = (4-100*coeff_b)/10;

gamma_l_function = @(t)( (coeff_b)*t^2+(coeff_a)*t)
gamma_l_T = arrayfun(gamma_l_function,intervalle_test);
[Y1_pert T1_pert] = log_influenza_sim(deb_sf,50,fin_sf,vect_Wu_function,CI_Wu,bs_dend,Tau,0.1,sf,gamma_l_function);
% % 
% plot(T1_pert,Y1_pert,'r',T1,Y1,'g')
% figure
% plot(T1,val_miss_fun)
% 

  Obs_l = Observation(T1_pert,Y1_pert); 
  bs_l = bSplines(Obs_l);


fonc_nls_gamma_l = @(vect_beta,t)(vect_beta*bsplineM(t+sf,[deb_sf+sf fin_sf+sf],3,0,0)');
func_min_gamma = @(vect_beta)(sum((fonc_nls_gamma_l(vect_beta,intervalle_test) -gamma_l_T).^2));
[val_est_beta val_res] = fminunc(func_min_gamma,[1 1 1]);
theta_ini_nls = [log(vect_Wu_function(1)) log(vect_Wu_function(2)) log(vect_Wu_function(3)) log(vect_Wu_function(4)) val_est_beta];

param_nls = est_param_nls_gradient_descent(Obs_l,v_field_nls,der_v_field_nls,der_v_field_theta_nls,3,[1 2 3],[theta_ini_nls CI_Wu],[],1)


%%

coeff_b = (9.5-9*4/5)/(36);
coeff_a = (4-25*coeff_b)/5;

gamma_l_function = @(t)( (coeff_b)*t^2+(coeff_a)*t)
gamma_l_T = arrayfun(gamma_l_function,intervalle_test);
fonc_nls_gamma_l = @(vect_beta,t)(vect_beta*bsplineM(t+sf,[deb_sf+sf fin_sf+sf],3,0,0)');
func_min_gamma = @(vect_beta)(sum((fonc_nls_gamma_l(vect_beta,intervalle_test) -gamma_l_T).^2));
[val_est_beta val_res] = fminunc(func_min_gamma,[1 1 1]);
est_nls_gamma_l_T = fonc_nls_gamma_l(val_est_beta,intervalle_test);

%% 
hold on
plot(intervalle_test,est_nls_gamma_l_T ,'g')


%% estimation gsa

v_field_gs = @(t,fd_cell,p)influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_gs = @(t,fd_cell,p)der_vect_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_theta_gs = @(t,fd_cell,p)der_vect_param_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_state_theta_gs = @(t,fd_cell,p)der_sec_vect_param_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));
der_v_field_state_state_gs = @(t,fd_cell,p)der_sec_vect_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(arrayfun(@(s)(10^func_inter_dend(s)),t)));


      Tcell = cell(1,3);
      Tcell{1} = res_t_sim_fun_sf(:,1);
      Tcell{2} = res_t_sim_fun_sf(:,1);
      Tcell{3} = res_t_sim_fun_sf(:,1);

      Ycell = cell(1,3);
      Ycell{1} = res_y_sim_fun_sf(:,1);
      Ycell{2} = res_y_sim_fun_sf(:,2);      
      Ycell{3} = res_y_sim_fun_sf(:,3);
      
     [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,log_param_ini_nls,v_field_gs, der_v_field_gs, der_v_field_theta_gs, der_v_field_state_state_gs, der_v_field_state_theta_gs);
     u_gsa = @(t)(evaluate_controle_gsa(t,newDEfd_cell,v_field_gs,res_est));


%%
v_field = @(t,vx,param,param_fixe)vect_field_influenza(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));

mat_obs_c = eye(3);
lambda_trial = 4:4:12

for nl = 1 : length(lambda_trial)
mat_U(1,1) = 10^(lambda_trial(nl));
mat_U(2,2) = 10^(lambda_trial(nl));
mat_U(3,3) = 10^(lambda_trial(nl)-3);

    try
    [est_param_g_ad,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,vect_Wu,CI_Wu,2);
    catch
        'erreur'
    end

    try
    [est_param_g_ad_dc,fval_g_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.8*vect_Wu,CI_Wu,2);
    catch
        'erreur dc'
    end

end


%% est param log transform
v_field = @(t,vx,param,param_fixe)vect_field_influenza_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));

mat_obs_c = eye(3);
lambda_trial = -2:1:30

mat_est_tr = zeros(length(lambda_trial),5);
mat_est_gd = zeros(length(lambda_trial),5);

mat_est_tr_dc = zeros(length(lambda_trial),5);
mat_est_gd_dc = zeros(length(lambda_trial),5);

vect_Wu_log = [log(vect_Wu(1)) log(vect_Wu(2)) log(vect_Wu(3)) log(vect_Wu(4)) log(vect_Wu(5))]

for nl = 1 : length(lambda_trial)
mat_U(1,1) = 10^(lambda_trial(nl));
mat_U(2,2) = 10^(lambda_trial(nl));
mat_U(3,3) = 10^(lambda_trial(nl));
% 
%     try
%     [est_param_gd,fval_gd] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.1*vect_Wu_log,CI_Wu,2);
%     mat_est_gd(nl,:) =reshape(est_param_gd,1,5);
%     catch
%         'erreur gd'
%     end

    try
    [est_param_tr,fval_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.2*vect_Wu_log,CI_Wu,1);
    mat_est_tr(nl,:) =reshape(est_param_tr,1,5);
    
    catch
        'erreur_tr'
    end

  
%     
%     try
%     [est_param_gd_dc,fval_gd_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.9*vect_Wu_log,CI_Wu,2);
%     mat_est_gd_dc(nl,:) =reshape(est_param_gd_dc,1,5);
%     catch
%         'erreur gd_dc'
%     end
    
      try
    [est_param_tr_dc,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.8*vect_Wu_log,CI_Wu,1);
    mat_est_tr_dc(nl,:) =reshape(est_param_tr_dc,1,5);
    
    catch
        'erreur_tr_dc'
    end



end


%% est param log transform with functional term with unknown ci
v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));

mat_obs_c = zeros(3,5);
mat_obs_c(1:3,1:3) = eye(3);
lambda_trial = -2:1:20

% mat_est_tr = zeros(length(lambda_trial),9);
% mat_est_tr_dc = zeros(length(lambda_trial),9);

vect_Wu_log_fun = [log(vect_Wu(1)) log(vect_Wu(2)) log(vect_Wu(4)) log(vect_Wu(5)) CI_Wu   0 2/9]

for nl = 6 : length(lambda_trial)
    
mat_U = zeros(5);    
mat_U(1,1) = 10^(lambda_trial(nl));
mat_U(2,2) = 10^(lambda_trial(nl));
mat_U(3,3) = 10^(lambda_trial(nl));
mat_U(4,4) = 0.1;
mat_U(5,5) = 0.1;

    try
    [est_param_tr,fval_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.1*vect_Wu_log_fun,[],1);
    mat_est_tr(nl,:) =reshape(est_param_tr,1,9);
    catch
        'erreur_tr'
    end
    save('test_influenza_sim_all_logvariables','mat_est_tr','mat_est_tr_dc','nl')

      try
    [est_param_tr_dc,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.9*vect_Wu_log_fun,[],1);
    mat_est_tr_dc(nl,:) =reshape(est_param_tr_dc,1,9);
    catch
        'erreur_tr_dc'
      end
     save('test_influenza_sim_all_logvariables','mat_est_tr','mat_est_tr_dc','nl')

end

%% simplified parameter estimation

v_field = @(t,vx,param,param_fixe)vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));

mat_obs_c = eye(3);
mat_U = 10*eye(3);

[est_param_g_ad,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,vect_Wu(3:5),CI_Wu,1,1,vect_Wu(1:2));

[est_param_g_ad_dc,fval_g_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.8*vect_Wu(3:5),CI_Wu_update1,1,vect_Wu(1:2)); 

%%

v_field = @(t,vx,param,param_fixe)vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_sp(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));

mat_obs_c = eye(3);
mat_U = zeros(3);

mat_U(1,1) = 10^8;
mat_U(2,2) = 10^8;
mat_U(3,3) = 10^5;

[est_param_g_ad,fval_g] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,vect_Wu(3:5),CI_Wu,1,1,vect_Wu(1:2));

[est_param_g_ad_dc,fval_g_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,0.8*vect_Wu(3:5),CI_Wu,1,1,vect_Wu(1:2)); 


%% semi parametric estimation with derivative and curvature penalization


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part = zeros(3,5);
mat_obs_c_part(1:3,1:3) = eye(3);


mat_U = zeros(5);

mat_U(1,1) = 10^8;
mat_U(2,2) = 10^8;
mat_U(3,3) = 10^5;
mat_U(4,4) = 0.1;
mat_U(5,5) = 0.1;



[est_param_g_ad,fval_g,bs_u_infl1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part,mat_U,vect_Wu_function(4),CI_Wu_ext,1,1,vect_Wu_function(1:3));

[est_param_g_ad_dc,fval_g_dc,bs_u_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part,mat_U,0.8*vect_Wu_function(4),CI_Wu_ext,1,1,vect_Wu_function(1:3)); 



%% semi parametric estimation with derivative only


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext2 = [CI_Wu 0];


mat_obs_c_part = zeros(3,4);
mat_obs_c_part(1:3,1:3) = eye(3);


mat_U = zeros(4);

mat_U(1,1) = 10^8;
mat_U(2,2) = 10^8;
mat_U(3,3) = 10^5;
mat_U(4,4) = 0.01;



[est_param_g_ad,fval_g,bs_u_infl1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part,mat_U,vect_Wu_function(4),CI_Wu_ext2,1,1,vect_Wu_function(1:3));

[est_param_g_ad_dc,fval_g_dc,bs_u_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part,mat_U,0.8*vect_Wu_function(4),CI_Wu_ext2,1,1,vect_Wu_function(1:3)); 

%%

T_sim = 0:0.09:9;

val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

vect_param_reconstitue = mat_est_tr_dc(15,1:4);

mat_U = zeros(5);    
mat_U(1,1) = 10^13;
mat_U(2,2) = 10^13;
mat_U(3,3) = 10^13;
mat_U(4,4) = 0.1;
mat_U(5,5) = 0.1;

 bs_u_infl1 = est_control_pontryagin(bs_sim_fun_sf,v_field,der_v_field,mat_obs_c,mat_U,vect_param_reconstitue,[CI_Wu  mat_est_tr_dc(15,5:6)]);
[Times_est res_x sol_ode_u] =  reconstruction_influenza_control(T_sim,vect_param_reconstitue,[Tau sf],[CI_Wu mat_est_tr_dc(15,5:6)],@(t)(10^func_inter_dend(t)),@(t)(bs_u_infl1.calcul_prediction(t,0)'));



plot(T_sim,val_gamma_l_function)
hold on
plot(T_sim,res_x(4,:))


%% semi parametric estimation with unknown ci

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext2 = [CI_Wu 0];


mat_obs_c_part2 = zeros(3,4);
mat_obs_c_part2(1:3,1:3) = eye(3);


mat_U2 = zeros(4);

mat_U2(1,1) = 10^8;
mat_U2(2,2) = 10^8;
mat_U2(3,3) = 10^5;
mat_U2(4,4) = 0.01;



[est_param_g_ad,fval_g,bs_u_infl1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part2,mat_U2,[vect_Wu_function(4) CI_Wu_ext2],[],1,1,vect_Wu_function(1:3));

[est_param_g_ad_dc,fval_g_dc,bs_u_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part2,mat_U2,0.9*[vect_Wu_function(4) CI_Wu_ext2],[],1,1,vect_Wu_function(1:3)); 



v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part = zeros(3,5);
mat_obs_c_part(1:3,1:3) = eye(3);


mat_U1 = zeros(5);

mat_U1(1,1) = 10^8;
mat_U1(2,2) = 10^8;
mat_U1(3,3) = 10^5;
mat_U1(4,4) = 0.1;
mat_U1(5,5) = 0.1;



[est_param_g_ad1,fval_g1,bs_u1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part,mat_U,[vect_Wu_function(4) CI_Wu_ext],[],1,1,vect_Wu_function(1:3));

[est_param_g_ad_dc1,fval_g_dc1,bs_u_dc1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part,mat_U,0.8*[vect_Wu_function(4) CI_Wu_ext],[],1,1,vect_Wu_function(1:3)); 


%% semi parametric estimation with known ci unknown functional parameter initial value

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp2(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext2 = [CI_Wu 0];


mat_obs_c_part2 = zeros(3,4);
mat_obs_c_part2(1:3,1:3) = eye(3);


mat_U2 = zeros(4);

mat_U2(1,1) = 10^8;
mat_U2(2,2) = 10^8;
mat_U2(3,3) = 10^5;
mat_U2(4,4) = 0.01;



[est_param_g_ad2,fval_g2,bs_u2] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part2,mat_U2,[vect_Wu_function(4) 0],CI_Wu ,1,1,vect_Wu_function(1:3));

[est_param_g_ad_dc2,fval_g_dc2,bs_u_dc2] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part2,mat_U2,0.9*[vect_Wu_function(4) 0.1],CI_Wu ,1,1,vect_Wu_function(1:3)); 


%% semi parametric estimation with known ci unknown functional parameter initial value

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp1(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part1 = zeros(3,5);
mat_obs_c_part1(1:3,1:3) = eye(3);


mat_U1 = zeros(5);

mat_U1(1,1) = 10^8;
mat_U1(2,2) = 10^8;
mat_U1(3,3) = 10^5;
mat_U1(4,4) = 0.1;
mat_U1(5,5) = 0.1;



[est_param_g_ad1,fval_g1,bs_u1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part1,mat_U1,[vect_Wu_function(4) 0 2/9],CI_Wu,1,1,vect_Wu_function(1:3));

[est_param_g_ad_dc1,fval_g_dc1,bs_u_dc1] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part1,mat_U1,0.9*[vect_Wu_function(4) 0.1 1/9],CI_Wu,1,1,vect_Wu_function(1:3)); 

%%

T_sim = 0:0.09:9;

val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

%param4 = est_param_g_ad_dc(1);
vect_param_reconstitue = [vect_Wu_function(1:2) exp(mat_est_tr_dc(4,1)) exp(mat_est_tr_dc(4,2))];



[Times_est res_x sol_ode_u] =  reconstruction_influenza_control(T_sim,vect_param_reconstitue,[Tau sf],[CI_Wu mat_est_tr_dc(4,3:4)],@(t)(10^func_inter_dend(t)),@(t)(bs_u_tr_dc.calcul_prediction(t,0)'));



plot(T_sim,val_gamma_l_function)
hold on
plot(T_sim,res_x(4,:))



%% non parametric and two parameters estimation with known ci unknown functional parameter initial value


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);


mat_U3 = zeros(5);

mat_U3(1,1) = 100;
mat_U3(2,2) = 100;
mat_U3(3,3) = 10;
mat_U3(4,4) = 1;
mat_U3(5,5) = 1;

try

[est_param_g_ad3,fval_g3,bs_u3] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[vect_Wu_function(3:4) 0 2/9],CI_Wu,1,1,vect_Wu_function(1:2));
catch
end

try
[est_param_g_ad_dc3,fval_g_dc3,bs_u_dc3] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.9*[vect_Wu_function(3:4) 0.1 1/9],CI_Wu,1,1,vect_Wu_function(1:2)); 
catch
end


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext4 = [CI_Wu 0];


mat_obs_c_part4 = zeros(3,4);
mat_obs_c_part4(1:3,1:3) = eye(3);


mat_U4 = zeros(4);

mat_U4(1,1) = 10^4;
mat_U4(2,2) = 10^4;
mat_U4(3,3) = 10^3;
mat_U4(4,4) = 0.01;


try
[est_param_g_ad4,fval_g4,bs_u4] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part4,mat_U4,[vect_Wu_function(3:4) 0],CI_Wu ,1,1,vect_Wu_function(1:2));
catch
end

try
[est_param_g_ad_dc4,fval_g_dc4,bs_u_dc4] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part4,mat_U4,0.9*[vect_Wu_function(3:4) 0.1],CI_Wu ,1,1,vect_Wu_function(1:2)); 
catch
end



%% non parametric and two parameters estimation with unknown ci unknown functional parameter initial value

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext3 = [CI_Wu 0 2/9];


mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);


mat_U3 = zeros(5);

mat_U3(1,1) = 10^4;
mat_U3(2,2) = 10^4;
mat_U3(3,3) = 10^3;
mat_U3(4,4) = 0.1;
mat_U3(5,5) = 0.1;


try
[est_param_g_ad3,fval_g3,bs_u3] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[vect_Wu_function(3:4) CI_Wu_ext3],[],1,1,vect_Wu_function(1:2));

catch
end

try
[est_param_g_ad_dc3,fval_g_dc3,bs_u_dc3] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.9*[vect_Wu_function(3:4) CI_Wu_ext3],[],1,1,vect_Wu_function(1:2)); 
catch
end


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp4(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext4 = [CI_Wu 0];


mat_obs_c_part4 = zeros(3,4);
mat_obs_c_part4(1:3,1:3) = eye(3);


mat_U4 = zeros(4);

mat_U4(1,1) = 10^4;
mat_U4(2,2) = 10^4;
mat_U4(3,3) = 10^3;
mat_U4(4,4) = 0.01;


try
[est_param_g_ad4,fval_g4,bs_u4] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part4,mat_U4,[vect_Wu_function(3:4) CI_Wu_ext4],[] ,1,1,vect_Wu_function(1:2));
catch
end

try
[est_param_g_ad_dc4,fval_g_dc4,bs_u_dc4] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part4,mat_U4,0.9*[vect_Wu_function(3:4) CI_Wu_ext4],[] ,1,1,vect_Wu_function(1:2)); 
catch
end


%% non parametric and two parameters try different lambda and optimization method


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);

lambda_trial = 4:4:16;

mat_est_tr = zeros(length(lambda_trial),4);
mat_est_gd = zeros(length(lambda_trial),4);

mat_est_tr_dc = zeros(length(lambda_trial),4);
mat_est_gd_dc = zeros(length(lambda_trial),4);

for nl = 1 : length(lambda_trial)
    
    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^lambda_trial(nl);
    mat_U3(2,2) = 10^lambda_trial(nl);
    mat_U3(3,3) = 10^(lambda_trial(nl)-2);
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

    
    try
     [est_param_g_tr,fval_tr,bs_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[vect_Wu_function(3:4) 0 2/9],CI_Wu ,1,1,vect_Wu_function(1:2));
      mat_est_tr(nl,:) = reshape(est_param_g_tr,1,4);
    catch
    end

    try
     [est_param_g_gd,fval_g_gd,bs_u_gd] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[vect_Wu_function(3:4) 0 2/9],CI_Wu,2,1,vect_Wu_function(1:2));
     mat_est_gd(nl,:) = reshape(est_param_g_gd,1,4);
    catch
    end
    
      
     try
     [est_param_g_tr_dc,fval_tr_dc,bs_u_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*[vect_Wu_function(3:4)  0 2/9],CI_Wu ,1,1,vect_Wu_function(1:2));
      mat_est_tr_dc(nl,:) = reshape(est_param_g_tr_dc,1,4);
    catch
    end

    try
     [est_param_g_gd_dc,fval_gd_dc,bs_u_gd_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*[vect_Wu_function(3:4) 0 2/9],CI_Wu,2,1,vect_Wu_function(1:2));
     mat_est_gd_dc(nl,:) = reshape(est_param_g_gd_dc,1,4);
    catch
    end


end


%% non parametric and two parameters with unknown ci try different lambda 


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);

lambda_trial = 2:4:18;

mat_est_tr = zeros(length(lambda_trial),7);


mat_est_tr_dc = zeros(length(lambda_trial),7);


for nl = 1 : length(lambda_trial)
    
    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^lambda_trial(nl);
    mat_U3(2,2) = 10^lambda_trial(nl);
    mat_U3(3,3) = 10^(lambda_trial(nl));
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

    
    try
     [est_param_g_tr,fval_tr,bs_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[vect_Wu_function(3:4) CI_Wu_ext],[] ,1,1,vect_Wu_function(1:2));
      mat_est_tr(nl,:) = reshape(est_param_g_tr,1,7);
    catch
        'erreur tr'
    end


    
      
     try
     [est_param_g_tr_dc,fval_tr_dc,bs_u_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,1.2*[vect_Wu_function(3:4)   CI_Wu_ext],[] ,1,1,vect_Wu_function(1:2));
      mat_est_tr_dc(nl,:) = reshape(est_param_g_tr_dc,1,7);
     catch
        'erreur tr dc'
    end

    

end


%% non parametric and two parameters try parametric log transform


v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log_sp3(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));


CI_Wu_ext = [CI_Wu 0 2/9];


mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);

lambda_trial = 8:4:20

mat_est_tr = zeros(length(lambda_trial),4);
mat_est_gd = zeros(length(lambda_trial),4);


mat_est_tr_dc = zeros(length(lambda_trial),4);
mat_est_gd_dc = zeros(length(lambda_trial),4);

val_log_ref = [log(vect_Wu_function(3)) log(vect_Wu_function(4)) ]

for nl = 1 : length(lambda_trial)
    
    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^lambda_trial(nl);
    mat_U3(2,2) = 10^lambda_trial(nl);
    mat_U3(3,3) = 10^(lambda_trial(nl)-2);
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

    
    try
     [est_param_g_tr,fval_tr,bs_u_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[log(vect_Wu_function(3)) log(vect_Wu_function(4))  0 2/9],CI_Wu ,1,1,vect_Wu_function(1:2));
      mat_est_tr(nl,:) = reshape(est_param_g_tr,1,4);
    catch
    end

    try
     [est_param_g_gd,fval_gd,bs_u_gd] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,[log(vect_Wu_function(3)) log(vect_Wu_function(4))  0 2/9],CI_Wu,2,1,vect_Wu_function(1:2));
     mat_est_gd(nl,:) = reshape(est_param_g_gd,1,4);
    catch
    end

    
     try
     [est_param_g_tr_dc,fval_tr_dc,bs_u_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*[log(vect_Wu_function(3)) log(vect_Wu_function(4))  0 2/9],CI_Wu ,1,1,vect_Wu_function(1:2));
      mat_est_tr_dc(nl,:) = reshape(est_param_g_tr_dc,1,4);
    catch
    end

    try
     [est_param_g_gd_dc,fval_gd_dc,bs_u_gd_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_sim_fun_sf,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*[log(vect_Wu_function(3)) log(vect_Wu_function(4))  0 2/9],CI_Wu,2,1,vect_Wu_function(1:2));
     mat_est_gd_dc(nl,:) = reshape(est_param_g_gd_dc,1,4);
    catch
    end


end


%% 1 rst estimation essay 2 param known ci second splines config

Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

param_ini_3rdcase = [sigma_m_s_3rdcase sigma_s_l_3rdcase 0 2/9];
param_fixe_3rdcase = [rho_m_3rdcase rho_s_3rdcase];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));



mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);

lambda_trial = 2:4:14

mat_est_tr = zeros(length(lambda_trial),4);
mat_est_gd = zeros(length(lambda_trial),4);

mat_est_tr_dc = zeros(length(lambda_trial),4);
mat_est_gd_dc = zeros(length(lambda_trial),4);

for nl = 1 : length(lambda_trial)
    
    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^lambda_trial(nl);
    mat_U3(2,2) = 10^lambda_trial(nl);
    mat_U3(3,3) = 10^(lambda_trial(nl)-2);
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

    
    try
     [est_param_g_tr,fval_tr,bs_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl_known_ci2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,param_ini_3rdcase,CI_Wu_3rdcase,1,1,param_fixe_3rdcase );
      mat_est_tr(nl,:) = reshape(est_param_g_tr,1,4);
    catch
         'erreur tr real data'
    end

    
      
     try
     [est_param_g_tr_dc,fval_tr_dc,bs_u_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl_known_ci2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*param_ini_3rdcase,CI_Wu_3rdcase,1,1,param_fixe_3rdcase );
      mat_est_tr_dc(nl,:) = reshape(est_param_g_tr_dc,1,4);
     catch
        'erreur tr dc real data'
    end

 
end


%% estimate control and functional parameter 1 rst estimation essay

T_sim = 0:0.2:9;

val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

%param4 = est_param_g_ad_dc(1);
vect_param_reconstitue = [param_fixe_3rdcase mat_est_tr_dc(5,1:2)];


[Times_est res_x sol_ode_u] =  reconstruction_influenza_control(T_sim,vect_param_reconstitue,[Tau_3rdcase sf_3rdcase],[CI_Wu_3rdcase mat_est_tr_dc(4,3:4)],@(t)(10^func_inter_dend(t)),@(t)(bs_tr.calcul_prediction(t,0)'));

calcul_control  = bs_tr.calcul_prediction(T_sim,0)

plot(T_sim,calcul_control(:,1),'rx',T_sim,calcul_control(:,2),'b--',T_sim,calcul_control(:,3),'go')
figure
plot(T_sim,res_x(4,:))



%% 2nd  estimation essay 2 param unknown ci

Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

param_ini_3rdcase = [sigma_m_s_3rdcase sigma_s_l_3rdcase CI_Wu_3rdcase 0 2/9];
param_fixe_3rdcase = [rho_m_3rdcase rho_s_3rdcase];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));



mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);

lambda_trial = 2:2:14;

mat_est_tr = zeros(length(lambda_trial),7);
mat_est_tr_dc = zeros(length(lambda_trial),7);

for nl = 1 : length(lambda_trial)
    
    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^lambda_trial(nl);
    mat_U3(2,2) = 10^lambda_trial(nl);
    mat_U3(3,3) = 10^(lambda_trial(nl)-2);
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

    
    try
     [est_param_g_tr,fval_tr,bs_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,param_ini_3rdcase,[],1,1,param_fixe_3rdcase );
      mat_est_tr(nl,:) = reshape(est_param_g_tr,1,7);
    catch
         'erreur tr real data 2nd case '
    end

    
      
     try
     [est_param_g_tr_dc,fval_tr_dc,bs_u_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*param_ini_3rdcase,[],1,1,param_fixe_3rdcase );
      mat_est_tr_dc(nl,:) = reshape(est_param_g_tr_dc,1,7);
     catch
        'erreur tr dc real data 2nd case'
    end

 
end



%% 2nd  estimation essay 2 param unknown ci 2nd spline config

Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

param_ini_3rdcase = [sigma_m_s_3rdcase sigma_s_l_3rdcase CI_Wu_3rdcase 0 2/9];
param_fixe_3rdcase = [rho_m_3rdcase rho_s_3rdcase];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));



mat_obs_c_part3 = zeros(3,5);
mat_obs_c_part3(1:3,1:3) = eye(3);

lambda_trial = [0 1 2:2:14];

mat_est_tr = zeros(length(lambda_trial),7);
mat_est_tr_dc = zeros(length(lambda_trial),7);

for nl = 1 : length(lambda_trial)
    
    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^lambda_trial(nl);
    mat_U3(2,2) = 10^lambda_trial(nl);
    mat_U3(3,3) = 10^(lambda_trial(nl)-2);
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

    
    try
     [est_param_g_tr,fval_tr,bs_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,param_ini_3rdcase,[],1,1,param_fixe_3rdcase );
      mat_est_tr(nl,:) = reshape(est_param_g_tr,1,7);
    catch
         'erreur tr real data 2nd case, 2nd spline config '
    end

    
      
     try
     [est_param_g_tr_dc,fval_tr_dc,bs_u_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c_part3,mat_U3,0.8*param_ini_3rdcase,[],1,1,param_fixe_3rdcase );
      mat_est_tr_dc(nl,:) = reshape(est_param_g_tr_dc,1,7);
     catch
        'erreur tr dc real data 2nd case, 2nd spline config '
    end

 
end


%% estimate control and functional parameter 1 rst estimation essay

    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^6;
    mat_U3(2,2) = 10^6;
    mat_U3(3,3) = 10^4;
    mat_U3(4,4) = 0.1;
    mat_U3(5,5) = 0.1;

T_sim = 0:0.2:9;

val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

%param4 = est_param_g_ad_dc(1);
vect_param_reconstitue = [param_fixe_3rdcase mat_est_tr_dc(5,1:2)];

 bs_sel = est_control_pontryagin(bs_infl2,v_field,der_v_field,mat_obs_c_part3,mat_U3,mat_est_tr_dc(5,1:2),mat_est_tr_dc(5,3:7),param_fixe_3rdcase );
[Times_est res_x sol_ode_u] =  reconstruction_influenza_control(T_sim,vect_param_reconstitue,[Tau_3rdcase sf_3rdcase],mat_est_tr_dc(5,3:7),@(t)(10^func_inter_dend(t)),@(t)(bs_sel.calcul_prediction(t,0)'));

calcul_control  = bs_sel.calcul_prediction(T_sim,0)

plot(T_sim,calcul_control(:,1),'rx',T_sim,calcul_control(:,2),'b--',T_sim,calcul_control(:,3),'go')
figure
plot(T_sim,res_x(4,:))


%% 
deb_sf = 0;
fin_sf = 9;

CI_Wu_3rdcase = [log(4430) log(3490) log(1330)];
rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;

Tau_3rdcase = 3.53;
sf_3rdcase = 5;
param_fixe_3rdcase = [rho_m_3rdcase rho_s_3rdcase];


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

std_sf= 0.04;

vect_Wu_function_3rdcase = [rho_m_3rdcase rho_s_3rdcase sigma_m_s_3rdcase sigma_s_l_3rdcase];
[res_y_sim_fun_sf res_t_sim_fun_sf] = log_influenza_sim(deb_sf,fin_sf,vect_Wu_function_3rdcase,CI_Wu_3rdcase,bs_dend,Tau_3rdcase,std_sf,sf_3rdcase,gamma_l_function);



Obs_sim = Observation(res_t_sim_fun_sf,res_y_sim_fun_sf);
bs_sim = bSplines(Obs_sim);

bs_sim.erreur(1)
%%

 v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase,sf_3rdcase],@(t)(10^func_inter_dend(t)));
 der_v_field =  @(t,vx,param,param_fixe)der_vect_field_influenza_fun_sp3(t,vx,param,param_fixe,[Tau_3rdcase,sf_3rdcase],@(t)(10^func_inter_dend(t)));
 

    mat_obs_c_part3 = zeros(3,5);
    mat_obs_c_part3(1:3,1:3) = eye(3);

    mat_U3 = zeros(5);

    mat_U3(1,1) = 10^14;
    mat_U3(2,2) = 10^14;
    mat_U3(3,3) = 10^12;
    mat_U3(4,4) = 10^0;
    mat_U3(5,5) = 10^0;

T_sim = 0:0.2:9;

val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

 bs_sel = est_control_pontryagin(bs_sim,v_field,der_v_field,mat_obs_c_part3,mat_U3,vect_Wu_function_3rdcase(3:4) ,[CI_Wu_3rdcase 0 2/9],param_fixe_3rdcase );
[Times_est res_x sol_ode_u] =  reconstruction_influenza_control(T_sim,vect_Wu_function_3rdcase ,[Tau_3rdcase sf_3rdcase],[CI_Wu_3rdcase 0 2/9],@(t)(10^func_inter_dend(t)),@(t)(bs_sel.calcul_prediction(t,0)'));

%calcul_control  = bs_sel.calcul_prediction(T_sim,0)

plot(T_sim,val_gamma_l_function)
hold on
plot(T_sim,res_x(4,:))



%% estimation essay with param log transform with known ci 1rst spline config


Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

CI_Wu_3rdcase = [log(4430) log(3490) log(1330)];


log_param_ini_3rdcase = [log(rho_m_3rdcase ) log(rho_s_3rdcase) log(sigma_m_s_3rdcase) log(sigma_s_l_3rdcase)  CI_Wu_3rdcase 0 2/9];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));

mat_obs_c = zeros(3,5);
mat_obs_c(1:3,1:3) = eye(3);
lambda_trial = -2:1:30

mat_est_log_real_case = zeros(length(lambda_trial),9);
mat_est_log_real_case_dc = zeros(length(lambda_trial),9);

for nl = 1 : length(lambda_trial)
    
mat_U = zeros(5);    
mat_U(1,1) = 10^(lambda_trial(nl));
mat_U(2,2) = 10^(lambda_trial(nl));
mat_U(3,3) = 10^(lambda_trial(nl));
mat_U(4,4) = 0.1;
mat_U(5,5) = 0.1;

    try
    [est_param_tr,fval_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl_known_ci1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.1*[log_param_ini_3rdcase],[],1);
    mat_est_log_real_case(nl,:) =reshape(est_param_tr,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_1rstconfig'
    end
    save('test_influenza_logvariables_ci_unknown_1rstconfig','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

      try
    [est_param_tr_dc,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl_known_ci1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,log_param_ini_3rdcase,[log_param_ini_3rdcase ],[],1);
    mat_est_log_real_case_dc(nl,:) =reshape(est_param_tr_dc,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_1rstconfig dc'
      end
     save('test_influenza_logvariables_ci_unknown_1rstconfig','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

end


%% estimation essay with param log transform with unknown ci 1rst spline config


Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

CI_Wu_3rdcase = [log(4430) log(3490) log(1330)];


log_param_ini_3rdcase = [log(rho_m_3rdcase ) log(rho_s_3rdcase) log(sigma_m_s_3rdcase) log(sigma_s_l_3rdcase)  CI_Wu_3rdcase 0 2/9];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));

mat_obs_c = zeros(3,5);
mat_obs_c(1:3,1:3) = eye(3);
lambda_trial = -2:2:30

mat_est_log_real_case = zeros(length(lambda_trial),9);
mat_est_log_real_case_dc = zeros(length(lambda_trial),9);



log_param_ini_3rdcase_maj = [-10.9002  -10.2852   -1.7774   -1.0768    8.1628   10.2794    6.7849 0 0];

for nl = 3 : length(lambda_trial)
    
mat_U = zeros(5);    
mat_U(1,1) = 10^(lambda_trial(nl));
mat_U(2,2) = 10^(lambda_trial(nl));
mat_U(3,3) = 10^(lambda_trial(nl));
mat_U(4,4) = 0.1;
mat_U(5,5) = 0.1;

    try
    [est_param_tr,fval_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.1*log_param_ini_3rdcase_maj,[],2);
    mat_est_log_real_case(nl,:) =reshape(est_param_tr,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_1rstconfig'
    end
    save('test_influenza_logvariables_true_ci_unknown_1rstconfig','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

      try
    [est_param_tr_dc,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl1,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,log_param_ini_3rdcase_maj,[],2);
    mat_est_log_real_case_dc(nl,:) =reshape(est_param_tr_dc,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_1rstconfig dc'
      end
     save('test_influenza_logvariables_true_ci_unknown_1rstconfig','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

end




%% estimation essay with param log transform with unknown ci 2nd spline config


Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

CI_Wu_3rdcase = [log(4430) log(3490) log(1330)];


log_param_ini_3rdcase = [log(rho_m_3rdcase ) log(rho_s_3rdcase) log(sigma_m_s_3rdcase) log(sigma_s_l_3rdcase)  CI_Wu_3rdcase 0 2/9];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));

mat_obs_c = zeros(3,5);
mat_obs_c(1:3,1:3) = eye(3);
lambda_trial = -2:2:30

mat_est_log_real_case = zeros(length(lambda_trial),9);
mat_est_log_real_case_dc = zeros(length(lambda_trial),9);

log_param_ini_3rdcase_maj =  [ -11.3120  -10.5140   -1.9657   -1.3979    8.5131   10.5234    6.8095 0 0]


for nl = 3 : length(lambda_trial)
    
mat_U = zeros(5);    
mat_U(1,1) = 10^(lambda_trial(nl));
mat_U(2,2) = 10^(lambda_trial(nl));
mat_U(3,3) = 10^(lambda_trial(nl));
mat_U(4,4) = 0.1;
mat_U(5,5) = 0.1;

    try
    [est_param_tr,fval_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.1*log_param_ini_3rdcase_maj,[],2);
    mat_est_log_real_case(nl,:) =reshape(est_param_tr,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_2ndconfig'
    end
    save('test_influenza_logvariables_true_ci_unknown_2ndconfig','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

      try
    [est_param_tr_dc,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,log_param_ini_3rdcase_maj,[],2);
    mat_est_log_real_case_dc(nl,:) =reshape(est_param_tr_dc,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_2ndconfig dc'
      end
     save('test_influenza_logvariables_true_ci_unknown_2ndconfig','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

end

%% estimation essay with param log transform with unknown ci 2nd spline config: 2nd derivative penalization only


Tau_3rdcase = 3.53;
sf_3rdcase = 5;

rho_m_3rdcase = 1.58*10^-5;
rho_s_3rdcase = 3.59*10^-5;


sigma_m_s_3rdcase = 1.77E-1;
sigma_s_l_3rdcase = 3.52E-1;

CI_Wu_3rdcase = [log(4430) log(3490) log(1330)];


mat_B_infl_2nd = zeros(5,1);
mat_B_infl_2nd(5,1) = 1;


log_param_ini_3rdcase = [log(rho_m_3rdcase ) log(rho_s_3rdcase) log(sigma_m_s_3rdcase) log(sigma_s_l_3rdcase)  CI_Wu_3rdcase 0 2/9];

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));

mat_obs_c = zeros(3,5);
mat_obs_c(1:3,1:3) = eye(3);
lambda_trial = [-4 -2 -1 0 1 2]

mat_est_log_real_case = zeros(length(lambda_trial),9);
mat_est_log_real_case_dc = zeros(length(lambda_trial),9);

log_param_ini_3rdcase_maj =  [ -11.3120  -10.5140   -1.9657   -1.3979    8.5131   10.5234    6.8095 0 0]


for nl = 3 : length(lambda_trial)
    
mat_U = 10^(lambda_trial(nl));    


    try
    [est_param_tr,fval_tr] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,1.1*log_param_ini_3rdcase_maj,[],mat_B_infl_2nd,1);
    mat_est_log_real_case(nl,:) =reshape(est_param_tr,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_2ndconfig_pen_2nd'
    end
    save('test_influenza_logvariables_true_ci_unknown_2ndconfig_pen_2nd','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

      try
    [est_param_tr_dc,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method(bs_infl2,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_obs_c,mat_U,log_param_ini_3rdcase_maj,[],mat_B_infl_2nd,1);
    mat_est_log_real_case_dc(nl,:) =reshape(est_param_tr_dc,1,9);
    catch
        'erreur test_influenza_logvariables_ci_unknown_2ndconfig dc'
      end
     save('test_influenza_logvariables_true_ci_unknown_2ndconfig_pen_2nd','mat_est_log_real_case','mat_est_log_real_case_dc','nl');

end


%% estimate functional term

v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));
der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau_3rdcase sf_3rdcase],@(t)(10^func_inter_dend(t)));

    mat_U3 = 10^lambda_trial(2);
    
    mat_obs_c_part3 = zeros(3,5);
    mat_obs_c_part3(1:3,1:3) = eye(3);

T_sim = 0:0.2:9;

val_gamma_l_function = arrayfun(gamma_l_function,T_sim);

%param4 = est_param_g_ad_dc(1);
vect_param_reconstitue = mat_est_log_real_case_dc(5,1:4);
vect_param_reconstitue_trans_inv = arrayfun(@(x)(exp(x)),vect_param_reconstitue)
ci_est = [mat_est_log_real_case_dc(5,5:9)];

 bs_sel = est_control_pontryagin(bs_infl2,v_field,der_v_field,mat_obs_c_part3,mat_U3,vect_param_reconstitue,ci_est,mat_B_infl_2nd);
[Times_est res_x sol_ode_u] =  reconstruction_influenza_control(T_sim,vect_param_reconstitue_trans_inv,[Tau_3rdcase sf_3rdcase],ci_est,@(t)(10^func_inter_dend(t)),@(t)(bs_sel.calcul_prediction(t,0)'));

calcul_control  = bs_sel.calcul_prediction(T_sim,0)

plot(T_sim,calcul_control(:,1),'rx',T_sim,calcul_control(:,2),'b--',T_sim,calcul_control(:,3),'go')
figure
plot(T_sim,res_x(4,:))

%%
2