function [Times_est res_x sol_ode_u state_rec_l2err state_rec_l2err_wu res_err_pred res_err_pred_wu err_l2] =  reconstruction_influenza_control(Times_est,param,x_0_tot,tr_param,tr_x_0,param_time,func_dend,control_est,gamma_l_fun,std,mat_b,pert_func)
    p_m =  param(1);
    p_s =  param(2);
    g_ms = param(3);
    g_sl = param(4);


    tr_p_m =  tr_param(1);
    tr_p_s =  tr_param(2);
    tr_g_ms = tr_param(3);
    tr_g_sl = tr_param(4);

    dim_syst = 3;
    
    nb_term_pen =  length(x_0_tot) - dim_syst;
    
    delay = param_time(1);
    time_shift = param_time(2);
    
    pas = Times_est(2)-Times_est(1);
    
    pres_pert = 1;
    
    if nargin < 12
        pres_pert = 0;
    end
    
    if nargin < 11
        mat_b = eye(dim_syst+nb_term_pen);
    end

    
    function dy = equ(t,y) 
        dy = zeros(dim_syst+nb_term_pen,1);

        dy(1) = (p_m*func_dend(t+time_shift-delay)-g_ms);
        dy(2) = (p_s*func_dend(t+time_shift-delay)-g_sl)+g_ms*exp(y(1)-y(2));
        dy(3) = g_sl*exp(y(2)-y(3)) -y(4);
        
        
        if nb_term_pen > 1
            dy((dim_syst+1):(dim_syst+nb_term_pen-1)) = y((dim_syst+2):(dim_syst+nb_term_pen));
        end

        dy = dy + mat_b*control_est(t);
    end


     sol_ode_u = ode45(@equ,Times_est,x_0_tot);

    function res_t = compute_param_gl(t)
        res_sol_t = deval(sol_ode_u,t);
        res_t = res_sol_t(4);
    end


    function dy = equ_simp_without_control(t,y) 
        dy = zeros(dim_syst,1);

        dy(1) = (p_m*func_dend(t+time_shift-delay)-g_ms);
        dy(2) = (p_s*func_dend(t+time_shift-delay)-g_sl)+g_ms*exp(y(1)-y(2));
        dy(3) = g_sl*exp(y(2)-y(3)) -compute_param_gl(t);     

    end


    function dy = true_champ_vect_state_param(t,y) 
        dy = zeros(dim_syst,1);

        dy(1) = (tr_p_m*func_dend(t+time_shift-delay)-tr_g_ms);
        dy(2) = (tr_p_s*func_dend(t+time_shift-delay)-tr_g_sl)+tr_g_ms*exp(y(1)-y(2));
        dy(3) = tr_g_sl*exp(y(2)-y(3)) -gamma_l_fun(t);   
        
        if pres_pert == 1
            dy = dy + reshape(pert_func(t),dim_syst,1);
        end

    end
     
    function res_t = compute_erreur(t)
        res_gl_est = compute_param_gl(t);
        gamma_l_fun_t = gamma_l_fun(t);
        res_t = (res_gl_est - gamma_l_fun_t).^2;
    end

    x_0 = x_0_tot(1:3);
    [res_t_sim x_pred] = ode45(@equ_simp_without_control,Times_est,x_0,Times_est);   
    [res_t_sim x_pred_wu] = ode45(@equ,Times_est,x_0_tot,Times_est);  
    [res_t_sim x_true]= ode45(@true_champ_vect_state_param,Times_est,tr_x_0,Times_est);
    
    sol_x_pred = ode45(@equ_simp_without_control,Times_est,x_0,Times_est); 
    sol_x_pred_wu = ode45(@equ,Times_est,x_0_tot,Times_est);    
    sol_x_true = ode45(@true_champ_vect_state_param,Times_est,tr_x_0,Times_est);
    
    
    pred_obs = zeros(length(Times_est),dim_syst);
    pred_obs_wu = zeros(length(Times_est),dim_syst);
    true_obs = zeros(length(Times_est),dim_syst);
    
    for ni = 1 :  length(Times_est)

        pred_obs(ni,:) = x_pred(ni,:);
        pred_obs_wu(ni,:) = x_pred_wu(ni,1:3);

        true_obs(ni,:) = x_true(ni,:);
    end

            
     res_err_pred = 0;
     res_err_pred_wu = 0;
     nb_gen = 100;
             
            for nb_g = 1 : nb_gen 
             res_y_bruite =  true_obs + std*randn(length(res_t_sim),dim_syst);
             res_err_pred = res_err_pred + sqrt(pas*sum(sum((res_y_bruite - pred_obs).^2)));
             res_err_pred_wu = res_err_pred_wu + sqrt(pas*sum(sum((res_y_bruite - pred_obs_wu).^2)));
            end
            
            res_err_pred = res_err_pred/nb_gen;
            res_err_pred_wu = res_err_pred_wu/nb_gen;
       
    function res_t = erreur_pointwise_state(t)
        res_t = (deval(sol_x_pred,t) - deval(sol_x_true,t)).^2;
    end

    function res_t = erreur_pointwise_state_wu(t)
        pred_wu_t = deval(sol_x_pred_wu,t);
        res_t = (pred_wu_t(1:3) - deval(sol_x_true,t)).^2;
    end

    state_rec_l2err = sqrt(quadv(@(t)(erreur_pointwise_state(t)),res_t_sim(1),res_t_sim(end)));
    state_rec_l2err_wu = sqrt(quadv(@(t)(erreur_pointwise_state_wu(t)),res_t_sim(1),res_t_sim(end)));
     
     res_x  = deval(sol_ode_u,Times_est);
     
     if nargout > 7
      err_l2 = sqrt(quadv(@compute_erreur,Times_est(1),Times_est(end)));
     end

end