%% Est param compare with nls n1 p1 MISSPE


load('ensemble_donne_utile.mat')
n_pop = 2;
n_bruit = 2;
n_pop_i = 1;
n_bruit_i = 1;


Obs_dend = Observation(data_moy(:,1),data_moy(:,2));
bs_dend = bSplines(Obs_dend);
func_inter_dend  = @(t)(bs_dend.calcul_prediction(t,0));
sample_dend = bs_dend.calcul_prediction(2:0.1:15);
sample_dend = arrayfun(@(x)10^x,sample_dend);

rho_m = 1.58*10^-5;
rho_s = 3.59*10^-5;
sigma_m_s = 1.77E-1;
sigma_s_l = 3.52E-1;

Tau = 3.53E+0;

gamma_l_function = @(t)(t+sin(pi*t/9));

nu_s = @(t)((t.^2)/10);

deb_sf = 0;
fin_sf = 9;
sf = 5;

dim_syst = 5;

vect_param = [rho_m rho_s  sigma_m_s sigma_s_l];
log_vect_param = [log(rho_m) log(rho_s)  log(sigma_m_s) log(sigma_s_l)];
vect_CI = [log(4430) log(3490) log(1330)];

pop_trial = [100 50];
std_trial = [0.1 0.2];

    repertoire = 'res_estimation_pontryagin_influenza_misspe_nus_n1p1_nls.mat';
    load_res = load(repertoire);      

    mat_est_nls =  load_res.mat_est_nls;        
    run_ini = load_res.run;
        
for run = (run_ini+1) : nb_run    
    run

   pas = pop_trial(n_pop_i);
   std = std_trial(n_bruit_i);    
         
    [Y1, T1] = log_influenza_nus_sim(deb_sf,pas,fin_sf,vect_param,vect_CI,bs_dend,Tau,std,sf,gamma_l_function,nu_s);
    Obs_l = Observation(T1,Y1);

  Akaike_score_ref = 10^20;
  nb_max_knots = 3;
  
    for nb_k = 2 : nb_max_knots
      nb_knots = 2+nb_k;
      knots_nls_cur = deb_sf:(fin_sf-deb_sf)/(nb_knots-2):fin_sf;
      knots_nls_cur(end) = fin_sf;

      theta_ini_nls = zeros(5+nb_knots,1);
      theta_ini_nls(1:4) = log_vect_param;


      v_field_nls =  @(t,vx,param,param_fixe)vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)),knots_nls_cur)
      der_v_field_nls = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)),knots_nls_cur);
      der_v_field_theta_nls = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)),knots_nls_cur);


      [param_nls_cur,fval,  Akaike_score] = est_param_nls_gradient_descent...
          (Obs_l,v_field_nls,der_v_field_nls,der_v_field_theta_nls,eye(3),0.9*theta_ini_nls,vect_CI)

       if Akaike_score < Akaike_score_ref;
           Akaike_score_ref = Akaike_score;
           param_nls = param_nls_cur;
           knots_nls = knots_nls_cur;
           param_exo_nls = @(t)(bsplineM(t,knots_nls,4,0,0)*param_nls((5:end)));
       end

     end

       err_gl_nls = quadv(@(t)((param_exo_nls(t) - gamma_l_function(t)).^2),deb_sf,fin_sf);


         mat_est_nls(run,1:4) = param_nls(1:4);
         mat_est_nls(run,5) = err_gl_nls;

          save(repertoire,'run','mat_est_nls');
end
    
