%% Est param compare with nls n1 p1

clear

warning off
load('ensemble_donne_utile.mat')
n_pop = 2;
n_bruit = 2;
n_pop_i = 1;
n_bruit_i = 1;

Obs_dend = Observation(data_moy(:,1),data_moy(:,2));
bs_dend = bSplines(Obs_dend);
func_inter_dend  = @(t)(bs_dend.calcul_prediction(t,0));
sample_dend = bs_dend.calcul_prediction(2:0.1:15);
sample_dend = arrayfun(@(x)10^x,sample_dend);

rho_m = 1.58*10^-5;
rho_s = 3.59*10^-5;


sigma_m_s = 1.77E-1;
sigma_s_l = 3.52E-1;

Tau = 3.53E+0;

gamma_l_function = @(t)(t+sin(pi*t/9));

deb_sf = 0;
fin_sf = 9;
sf = 5;

dim_syst = 5;

vect_param = [rho_m rho_s  sigma_m_s sigma_s_l];
log_vect_param = [log(rho_m) log(rho_s)  log(sigma_m_s) log(sigma_s_l)];
vect_CI = [log(4430) log(3490) log(1330)];
vect_CI_ext = [vect_CI 0 (1+pi/9)];

mat_C_ext = zeros(3,5);
mat_C_ext(1:3,1:3) = eye(3);

mat_B_ext = zeros(5,4);
mat_B_ext(1:3,1:3) = eye(3);
mat_B_ext(5,4) = 1;

lambda_trial = [10 100 1000 10000 100000]


    v_field = @(t,vx,param,param_fixe)vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
    der_v_field = @(t,vx,param,param_fixe)der_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
    der_v_field_theta = @(t,vx,param,param_fixe)der_param_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
    der_v_field_state_theta = @(t,vx,param,param_fixe)der_state_param_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
    der_v_field_state_state = @(t,vx,param,param_fixe)der_sec_vect_field_influenza_fun_log(t,vx,param,param_fixe,[Tau sf],@(t)(10^func_inter_dend(t)));
    
 
  
nb_run = 100;

pop_trial = [100 50];
std_trial = [0.1 0.2];

    repertoire = 'res_estimation_pontryagin_influenza_n1p1.mat';
    load_res = load(repertoire);      
    
    mat_est_oc_opt_errpred2 = load_res.mat_est_oc_opt_errpred2;    
    mat_est_gsa = load_res.mat_est_gsa;

    run_ini = load_res.run;
        
    for run = (run_ini+1) : nb_run    
    run


    pas = pop_trial(n_pop_i);
    std = std_trial(n_bruit_i);
    
         
    [Y1, T1] = log_influenza_sim(deb_sf,pas,fin_sf,vect_param,vect_CI,bs_dend,Tau,std,sf,gamma_l_function);

    intervalle_int2 = zeros(2,2);
    intervalle_int2(1,:) = [T1(1) T1(50)];
    intervalle_int2(2,:) = [T1(50) T1(100)];

    Obs_l = Observation(T1,Y1); 
    bs_l = bSplines(Obs_l);    
    
      Tcell = cell(1,3);
      Tcell{1} = T1(:,1);
      Tcell{2} = T1(:,1);
      Tcell{3} = T1(:,1);

      Ycell = cell(1,2);
      Ycell{1} = Y1(:,1);
      Ycell{2} = Y1(:,2);
      Ycell{3} = Y1(:,3);
 
      err_pred2_cur = 10^50;
      
      param_ini_oca = 0.9*[log_vect_param 0 (1+pi/9)];
      
      for nl = 1 : length(lambda_trial)

          mat_U = zeros(4);
          mat_U(1:3,1:3) = lambda_trial(nl)*eye(3);
          mat_U(4,4) = 0.1;

        try
        [est_param_oca_tot_cur,fval_tr_dc] = est_param_pontryagin_bvp4c_adjoint_method...
            (bs_l,v_field,der_v_field,der_v_field_theta,der_v_field_state_theta,der_v_field_state_state,mat_C_ext,mat_U,param_ini_oca,vect_CI,mat_B_ext);  

         param_ini_oca = est_param_oca_tot_cur;
         
         est_param_oca_cur =  est_param_oca_tot_cur(1:4);
         est_vect_CI_ext = [vect_CI est_param_oca_tot_cur(5:6)];

         bs_u = est_control_pontryagin(bs_l,v_field,der_v_field,mat_C_ext,mat_U,est_param_oca_cur,est_vect_CI_ext,mat_B_ext);
         sol_Xu = pontryagin_compute_controlled_solution(bs_u,v_field,est_param_oca_cur,est_vect_CI_ext,mat_B_ext);
         sol_Xu_T1 = deval(sol_Xu,T1);

         bs_gl = bSplines(Observation(T1,sol_Xu_T1(4,:)'));
         v_field_gl = @(t,vx,param)vect_field_influenza_log_gl(t,vx,param,[Tau sf],@(t)(10^func_inter_dend(t)),bs_gl);

         err_l2_gl_oca = quadv(@(t)((bs_gl.calcul_prediction(t,0) - gamma_l_function(t)).^2),deb_sf,fin_sf);

         res_err_pred2 = pontryagin_prediction_error_semiparam_multi_inter...
             (bs_l,bs_u,v_field,v_field_gl,eye(3),est_param_oca_cur,est_vect_CI_ext,intervalle_int2,mat_B_ext)

         
         if res_err_pred2 < err_pred2_cur
             err_pred2_cur = res_err_pred2;
             est_param_oca_err_pred2 = est_param_oca_cur;
             err_gl_oca_err_pred2 =  err_l2_gl_oca;           
         end


        catch     
            'echec' 
            nl
        end

      end 
     


   param_nls = zeros(1,4);
   err_gl_nls = 0;
   
   Akaike_score_gsa_ref = 10^20;
   nb_max_knots_gsa = 4;

      for nb_k =2 : nb_max_knots_gsa
      nb_knots = 2+nb_k;
      knots_gsa_cur = deb_sf:(fin_sf-deb_sf)/(nb_knots-2):fin_sf;
      knots_gsa_cur(end) = fin_sf;

      theta_ini_gsa = zeros(5+nb_knots,1);
      theta_ini_gsa(1:4) = log_vect_param;


        fn       = @(t,fd_cell,p)influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(10.^func_inter_dend(t)),knots_gsa_cur);    % RHS function
        dfdx     = @(t,fd_cell,p)der_vect_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(10.^func_inter_dend(t)),knots_gsa_cur) ;   % Derivative wrt inputs (Jacobian)
        dfdp     = @(t,fd_cell,p)der_vect_param_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(10.^func_inter_dend(t)),knots_gsa_cur) ;     % Derviative wrt parameters
        d2fdx2   = @(t,fd_cell,p)der_sec_vect_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(10.^func_inter_dend(t)),knots_gsa_cur) ;    % Hessian wrt inputs
        d2fdxdp  = @(t,fd_cell,p)der_sec_vect_param_influenza_fun_gs(t,fd_cell,p,[Tau sf],@(t)(10.^func_inter_dend(t)),knots_gsa_cur);  % Hessian wrt inputs and parameters


        champ_vect_sparam =  @(t,vx,param,param_fixe)vect_field_influenza_fun_log_nls(t,vx,param,param_fixe,[Tau sf],@(t)(10.^func_inter_dend(t)),knots_gsa_cur)

        [est_gsa_cur est_x0_gsa_cur newDEfd_cell] = est_param_gsa(Tcell,Ycell, 0.9*theta_ini_gsa,fn, dfdx, dfdp, d2fdx2, d2fdxdp,[],champ_vect_sparam)

         val_etat_smooth =  @(t)(cell2mat(eval_fdcell(t,newDEfd_cell,0)));
         val_pred = cell2mat(arrayfun(val_etat_smooth,T1,'UniformOutput',false));

         residual_gsa = sum(sum((Y1(:,1:3) - val_pred(:,1:3)).^2)); 
         Akaike_score_gsa = 3*length(T1)*log(residual_gsa/3*length(T1)) + 2*length(theta_ini_gsa);
          if Akaike_score_gsa < Akaike_score_gsa_ref;
               Akaike_score_gsa_ref = Akaike_score_gsa;
               est_gsa = est_gsa_cur;
               knots_gsa = knots_gsa_cur;
               param_exo_gsa = @(t)(bsplineM(t,knots_gsa,4,0,0)*reshape(est_gsa(5:end), length(est_gsa(5:end)),1));
          end
      end

   err_gl_gsa = quadv(@(t)((param_exo_gsa(t) - gamma_l_function(t)).^2),deb_sf,fin_sf)
            
      
     mat_est_oc_opt_errpred2(run,1:4) = est_param_oca_err_pred2;
     mat_est_oc_opt_errpred2(run,5) = err_gl_oca_err_pred2;

     mat_est_gsa(run,1:4) = est_gsa(1:4);
     mat_est_gsa(run,5) = err_gl_gsa;

      save(repertoire,'run','mat_est_oc_opt_errpred2','mat_est_gsa');
    end
    
  