function [dist_est_non_param dist_est_data] = est_pontryagin_calcul_distance(bs,vect_field,mat_Obs,est_param,x_0,est_u,mat_b,param_fixe)

    Obs = bs.getObservation();
    T_c = Obs.getTimes();
    Times = T_c{1};
    Data_c = Obs.getMatrix();

    dim_syst = length(mat_Obs(1,:));
    dim_obs = length(mat_Obs(:,1));

    pas_solve =400;
    Int_ode_solve = Times(1):((Times(end)-Times(1))/pas_solve):Times(end); 
    
    if nargin < 8
        param_fixe = [];
    end
    
        
    if nargin < 7
        mat_b = eye(dim_syst);
    end
    dim_control = length(mat_b(1,:));
    
    pres_control = 1;
    
    if nargin < 6
        est_u = [];
    end
    
    if isempty(est_u)
        pres_control = 0;
    end

    function res_t = champ_vect_state_param(t,vx)
        pert = zeros(dim_control,1);
        if pres_control ==1
            pert = reshape(est_u(t),dim_control,1);
        end
        res_t = vect_field(t,vx,est_param,param_fixe)+ mat_b*pert;
    end
       
    sol_x = ode45(@champ_vect_state_param,Int_ode_solve,x_0);    
    
     function res_t = distance_non_param_t(t)
        val_x_t = deval(sol_x,t);
        y_hat = bs.calcul_prediction(t,0);
        y_hat = reshape(y_hat,dim_obs,1);
        res_t = sum((mat_Obs* val_x_t - y_hat).^2);
     end
 
     function res_t = val_pred_model_t(t)
        val_x_t = deval(sol_x,t);
        res_t = mat_Obs* val_x_t;
     end



    dist_est_non_param = sqrt(quadv(@distance_non_param_t,Times(1),Times(end)));

    res_est_obs_pred = arrayfun(@(t)(val_pred_model_t(t)),Times,'UniformOutput',false)';
    res_est_obs_pred = cell2mat(res_est_obs_pred)';
    res_data = cell2mat(Data_c');
    dist_est_data = sqrt(sum(sum((res_est_obs_pred-res_data).^2)));
end