function res_err_pred = pontryagin_prediction_error_multi_inter(bs_l,bs_u,v_field,mat_C,est_param,x0,intervalle_int,mat_B)
    Obs = bs_l.getObservation();
    T_c = Obs.getTimes();
    Times = T_c{1};
    Data_c = Obs.getMatrix();
    res_data = cell2mat(Data_c');
    dim_syst = length(x0);
    pas_solve =400;
    Int_ode_solve = Times(1):((Times(end)-Times(1))/pas_solve):Times(end); 
    
    if nargin < 8
        mat_B = eye(dim_syst);
    end

    nb_obs =  length(Times);
    nb_inter_tot = length(intervalle_int(:,1));

    function res_t = champ_vect_controlled(t,vx)
        u_t = bs_u.calcul_prediction(t,0);
        res_t = v_field(t,vx,est_param,[])+ mat_B*reshape(u_t,length(u_t),1);
    end

    function res_t = champ_vect_uncontrolled(t,vx)
        res_t = v_field(t,vx,est_param,[]);
    end

    sol_controlled = ode45(@champ_vect_controlled,Int_ode_solve,reshape(x0,dim_syst,1)); 
    
    sum_err_pred = 0;

              for ninter = 1 : nb_inter_tot
                 Inter_n_int = intervalle_int(ninter,:);
                 Times_n_int = Times(find(Times==Inter_n_int(1)):find(Times==Inter_n_int(2)));
                 nb_obs_ninter = length(Times_n_int);
                 
                 Int_ode_solve_cur = Inter_n_int(1):((Inter_n_int(2)-Inter_n_int(1))/pas_solve):Inter_n_int(2);
                 val_ini_ninter = deval(sol_controlled,Times_n_int(1));
                 sol_uncontrolled_ninter = ode45(@champ_vect_uncontrolled,Int_ode_solve_cur,reshape(val_ini_ninter,dim_syst,1));

                  
                 for i = 1 : nb_obs_ninter
                     val_pred_i = deval(sol_uncontrolled_ninter,Times_n_int(i));
                     indice_i = find(Times==Times_n_int(i));
                     
                     sum_err_pred = sum_err_pred  + sum((res_data(indice_i,:)' - mat_C*val_pred_i).^2);
                 end
                  
              end
                 res_err_pred = sum_err_pred/nb_obs;
                
              
end