function [res_est res_x0 newDEfd_cell] = est_param_gsa(Tcell,Ycell,param_ini,vffun,vfdfdx,vfdfdp,vfd2fdx2,vfd2fdxdp,vfd2fdp2,champ_vect,nknots,lambda_trial)
% First we need a function to calculate the functionl directly.

fn.fn       = vffun;       % RHS function

% Now derivatives of the function with respect to system components and
% parameters

fn.dfdx     = vfdfdx;      % Derivative wrt inputs (Jacobian)
fn.dfdp     = vfdfdp;      % Derivative wrt parameters

% Now we need functions to compute all three sets of second derivatives:

fn.d2fdx2   = vfd2fdx2;    % Hessian wrt inputs
fn.d2fdxdp  = vfd2fdxdp;   % Hessian wrt inputs and parameters

if nargin > 8
    fn.d2fdp2   = vfd2fdp2;    % Hessian wrt parameters.
end


test_trial = 0;
if nargin > 11
    test_trial = 1;
end

if isempty(Tcell{1})
    t_1val = Tcell{2};
else
    t_1val = Tcell{1};
end


wts = zeros(1,length(Ycell));
for i = 1:length(Ycell)
    if ~isempty(Ycell{i})
        wts(i) = 1./sqrt(var(Ycell{i}));
    else
        wts(i) = 1;
    end
end

param_ini = reshape(param_ini,length(param_ini),1);

lambda0 = 1;

    if nargin < 12
     nknots = length(t_1val);
    end
norder = 3;
nquad = 5;
lsopts_out = optimset('DerivativeCheck','off','Jacobian','on',...
    'Display','iter','MaxIter',1000,'TolFun',1e-8,'TolX',1e-10);

lsopts_in = optimset('DerivativeCheck','off','Jacobian','on',...
    'Display','off','MaxIter',1000,'TolFun',1e-14,'TolX',1e-14,...
    'JacobMult',@SparseJMfun);

range = [t_1val(1),t_1val(end)];
knots = reshape(t_1val,1,nknots);
nbasis = nknots+norder-2;
quadvals = [knots' ones(length(knots),1)/nknots];

Lfd_cell = cell(1,length(Ycell));

bbasis = MakeBasis(range,nbasis,norder,knots,quadvals,1);

Lfd_cell(:) = {fdPar(bbasis,1,lambda0)};

DEfd_ini = smoothfd_cell(Ycell,Tcell,Lfd_cell);


    function res_t = penality_error(t,fd_cell,param)
        champvect = fn.fn(t,fd_cell,param);
        derivate = eval_fdcell(t,fd_cell,1);
        res_t = sum((cell2mat(champvect) - cell2mat(derivate)).^2);
    end

lambda_cur = 10;
lambda_cur = lambda_cur * wts


DEfd_cur = DEfd_ini;


err_im1 = 10^200;
err_i = 10^199;


if test_trial == 1
       [est_prem,newDEfd_prem] = Profile_GausNewt(param_ini,lsopts_out,DEfd_cur ,fn,...
            lambda_trial(1),Ycell,Tcell,wts,[],lsopts_in);

    res_est = zeros(length(lambda_trial),length(param_ini));
    newDEfd_cell = cell(length(lambda_trial),1);
    
    newpreds = @(t)(cell2mat(eval_fdcell(t,newDEfd_prem,0)));
    x0_prem = newpreds(t_1val(1));
    res_x0 = zeros(length(lambda_trial),length(x0_prem));
    
    res_est(1,:) = est_prem;
    newDEfd_cell{1} = newDEfd_prem;
    res_x0(1,:) = x0_prem;
    
      for nnl = 2: length(lambda_trial)
           [res_cur,newDEfd_cur] = Profile_GausNewt(param_ini,lsopts_out,DEfd_cur ,fn,...
            lambda_trial(nnl),Ycell,Tcell,wts,[],lsopts_in);
            newpreds = @(t)(cell2mat(eval_fdcell(t,newDEfd_cur,0)));
            x0_cur = newpreds(t_1val(1));
            %DEfd_cur = newDEfd_cur;
            

            res_est(nnl,:) = res_cur;
            newDEfd_cell{nnl} = newDEfd_cur;
            res_x0(nnl,:) = x0_cur;   
        
      end

else
   while err_im1 > 1.1*err_i
    [res_est_cur,newDEfd_cell_cur] = Profile_GausNewt(param_ini,lsopts_out,DEfd_cur ,fn,...
        lambda_cur,Ycell,Tcell,wts,[],lsopts_in);

     newpreds = @(t)(cell2mat(eval_fdcell(t,newDEfd_cell_cur,0)));
     res_x0_cur = newpreds(t_1val(1));


     res_x_exacte = ode45(@(t,y)champ_vect(t,y,res_est_cur,[]),t_1val,res_x0_cur);

     function_diff = @(t)((newpreds(t)'-deval(res_x_exacte,t)).^2);

     err_im1 = err_i
     err_i = quadv(@(t)(sum(function_diff(t))),t_1val(1),t_1val(end))

     lambda_cur = 10*lambda_cur;
     DEfd_cur  = newDEfd_cell_cur;
     
        if err_i < err_im1
            res_est = res_est_cur;
            res_x0 = res_x0_cur;
            newDEfd_cell = DEfd_cur;
        end
    end
end

end