function res = calcul_der_lisseur_kernel(Bs,X,nb_obs)
obs = Bs.getObservation();
T_c = obs.getTimes();
T = T_c{nb_obs};
C = Bs.getBandwiths();
Kernel = Bs.getFoncKernel();
Kernel_der = Bs.getFoncKernel_der();

res = zeros(length(T),length(X));

for i = 1 : length(X)
    H = arrayfun(Kernel,X(i) -T,C{1,nb_obs}.*ones(length(T),1));
    H_der = arrayfun(Kernel_der,(X(i) -T)./C{1,nb_obs});
    sum_H = sum(H);
    sum_H_der = sum(H_der);
    res(:,i) = (H_der.*sum_H - sum_H_der.*H )./((C{1,nb_obs}*sum_H).^2);
end

end