function x_res = calcul_derivee_prediction(r,X,variable)
% Calcul les valeurs attendu de la derivee de la regression pour les valeurs contenu dans X
% Renvoie une matrice de taille : taille de X * dimension des observations
% Argument :
% r ..... objet kernelRegression contenant la base de regression
% X...... vecteur contenant les valeurs 

obs = r.getObservation();
T_c = obs.getTimes();
C = r.getBandwiths();
Mat_res_c = obs.getMatrix();
Kernel = r.getFoncKernel();
Kernel_der = getFoncKernel_der(r);

longueur = length(C(1,:));


if nargin < 3
x_res = zeros(length(X),longueur);
for l = 1 : longueur
    
T = T_c{l};
Mat_res = Mat_res_c{l}; 
X_mat = zeros(length(X),length(T));    
for i = 1 : length(T)
    X_mat(:,i) = X;
end

T_mat=  zeros(length(T),length(X));
for i = 1 : length(X)
    T_mat(:,i) = T;
end

aux_mat = (X_mat - (T_mat)')';
H = arrayfun(Kernel,aux_mat,C{1,l}.*ones(length(T),length(X)));
sum_H = sum(H);
H_der = arrayfun(Kernel_der,aux_mat./C{1,l});
sum_H_der = sum(H_der);

for j = 1 : length(X)
    der(:,j) = (H_der(:,j).*sum_H(j) - H(:,j).*sum_H_der(j))./((C{1,l}.*sum_H(j))^2);
end
x_res(:,l) = der'*Mat_res;
end

%cas 4 param entree
else
    x_res = zeros(length(X),length(variable)); 
    for nj = 1 : length(variable)
    T = T_c{variable(nj)};
    Mat_res = Mat_res_c{variable(nj)}; 
    X_mat = zeros(length(X),length(T));    
    for i = 1 : length(T)
        X_mat(:,i) = X;
    end

    T_mat=  zeros(length(T),length(X));
    for i = 1 : length(X)
       T_mat(:,i) = T;
    end

    aux_mat = (X_mat - (T_mat)')';
    H = arrayfun(Kernel,aux_mat,C{1,variable(nj)}.*ones(length(T),length(X)));
    sum_H = sum(H);
    H_der = arrayfun(Kernel_der,aux_mat./C{1,variable(nj)});
    sum_H_der = sum(H_der);

    for j = 1 : length(X)
       der(:,j) = (H_der(:,j).*sum_H(j) - H(:,j).*sum_H_der(j))./((C{1,variable(nj)}.*sum_H(j))^2);
    end
    x_res = der'*Mat_res;
    
    end
end

end