function x_res = calcul_prediction_direct(r,X,variable)
% Calcul les valeurs attendu dans la base de regression pour les valeurs contenu dans X
% Renvoie une matrice de taille : taille de X * dimension des observations
% Argument :
% r ..... objet kernelRegression contenant la base de regression
% X...... vecteur contenant les valeurs 

obs =  getObservation(r);
T_c = obs.getTimes();
C = r.getBandwiths();
Mat_res_c = obs.getMatrix();
Kernel = r.getFoncKernel();
longueur = length(C(1,:));
x_res = zeros(length(X),longueur); 


if nargin < 3
for l = 1 : longueur
    T  =T_c{l};
    Mat_res = Mat_res_c{l};
    X_mat = zeros(length(X),length(T));
    
for i = 1 : length(T)
    X_mat(:,i) = X;
end

T_mat=  zeros(length(T),length(X));
for i = 1 : length(X)
    T_mat(:,i) = T;
end

aux_mat = (X_mat - (T_mat)')';

H = arrayfun(Kernel,aux_mat,C{1,l}.*ones(length(T),length(X)));
sum_H = sum(H);

for j = 1 : length(X)
    H(:,j) = H(:,j) ./sum_H(j);
end
x_res(:,l) = H'*Mat_res;
end
else
    for nj = 1 : length(variable)
    T  =T_c{variable(nj)};
    Mat_res = Mat_res_c{variable(nj)};
    X_mat = zeros(length(X),length(T));
    
    for i = 1 : length(T)
        X_mat(:,i) = X;
    end

    T_mat=  zeros(length(T),length(X));
    for i = 1 : length(X)
        T_mat(:,i) = T;
    end

    aux_mat = (X_mat - (T_mat)')';

    H = arrayfun(Kernel,aux_mat,C{1,variable(nj)}.*ones(length(T),length(X)));
    sum_H = sum(H);

    for j = 1 : length(X)
       H(:,j) = H(:,j) ./sum_H(j);
    end
    x_res = H'*Mat_res;  
    
    end
    end

end