function [variance,temps_calc]=compute_variance_nls(Obs,model,theta0,x00,dimension,freeparam)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%model : structure of function handler, ode function vf(t,x,theta)
%
%freeparam : 0 = optimize in theta and x0
%            1 = optimize in theta (x0 fixed with input value x0)
%               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic

if nargin < 6
   freeparam = 0;
end

if nargin < 5
    dimension = 1;
end

real_dimension = length(x00) - dimension +1;

T_c = Obs.getTimes();
Obs_c = Obs.getMatrix();
%dim = length(T_c);
Times = T_c{1};
a = Times(1);
b = Times(end);

if freeparam == 0
sol = model(a,b,[theta0 x00]);
nb_param_total = length(x00)+length(theta0);
else
sol = model(a,b,theta0,x00);
nb_param_total = length(theta0);
end

    function [res res_val] = func_aux(t)
        res_tot = deval(sol,t);
        res = res_tot(length(x00)+1:length(res_tot));
        res_val = res_tot(1:length(x00));
        res_val = res_val(1:real_dimension);

        res = reshape(res,length(x00),nb_param_total);
        res = res(1:real_dimension,:);

    end


% variance = cell(real_dimension,1);
% 
% for gt = 1 : real_dimension
%     variance{gt} = zeros(nb_param_total);
% end

bruit = zeros(real_dimension,1);

M_e = zeros(nb_param_total);
for nj = 1 : length(Times)
    [res_temp res_val_temp]  = func_aux(Times(nj));

    %res_temp
    vect = zeros(real_dimension,1);
    for ni = 1 : real_dimension
        data_ni = Obs_c{ni};
        vect(ni) = data_ni(nj);
       % variance{ni} = variance{ni} + res_temp(ni,:)'*res_temp(ni,:);
    end
    
    
    bruit = bruit + (res_val_temp - vect).^2;    
end


bruit = bruit/length(Times);
bruit = arrayfun(@sqrt,bruit);
bruit = ones(length(bruit),1)./bruit;
bruit = diag(bruit);
%variance_sum = zeros(nb_param_total);


for nnj = 1 : length(Times)
    %variance{nni}
    [res_temp res_val_temp]  = func_aux(Times(nj));
    
    M_e = M_e + res_temp'*bruit*res_temp;

end

M_e = M_e/length(Times);

M_e
variance = pinv(M_e)/length(Times);

% for nni = 1 : real_dimension
%     %variance{nni}
%     variance_sum = variance_sum + (1/bruit(nni))*variance{nni};
% end
% 
% variance = inv(variance_sum)/length(Times);

temps_calc = toc;
end 