function [variance,temps_calc]=compute_variance_nls_anc_version(Obs,model,theta0,x00,std,freeparam)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%model : structure of function handler, ode function vf(t,x,theta)
%
%freeparam : 0 = optimize in theta and x0
%            1 = optimize in theta (x0 fixed with input value x0)
%               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tic

if nargin < 6
   freeparam = 0;
end

T_c = Obs.getTimes();
Times = T_c{1};
a = Times(1);
b = Times(end);

if freeparam == 0
sol = model(a,b,[theta0 x00]);
else
sol = model(a,b,theta0,x00);
end

    function res = func_aux(t)
        res = deval(sol,t);
        res = res(length(x00)+1:length(res));
        if freeparam == 0
        res = reshape(res,length(x00),length(x00)+length(theta0));
        else
        res = reshape(res,length(x00),length(theta0));    
        end
        res = res'*res;
    end

calcul = quadv(@func_aux,a,b);
%calcul = res_integ'*res_integ;
variance = (((b-a).*std.^2)./(length(Times)))*pinv(calcul);

temps_calc = toc;
end 