function [est_param,fval, Akaike_score] = est_param_nls_gradient_descent(Obs,vect_field,der_vect_field,der_vect_field_theta,mat_c,param_ini,x_0,type_solver,param_fixe)


    T_c = Obs.getTimes();
    Data_c= Obs.getMatrix();
    Times = T_c{1};
	nb_obs = length(Times);

    
    dim_obs =  length(mat_c(:,1));
	dim_syst = length(mat_c(1,:));
    Data_mat = reshape(cell2mat(Data_c')',nb_obs*dim_obs,1);

    pas_solve =200;
    Int_ode_solve = Times(1):((Times(end)-Times(1))/pas_solve):Times(end);          
    
    free_ci = 0;
    if nargin < 7
        x_0 = [];
    end
    
     if isempty(x_0)
        free_ci = 1;
     end
     
     
    if nargin < 8
        type_solver = 1;
    end
    
    if nargin < 9
        param_fixe = [];
    end
    
     gradient_use = 1;
    if isempty(der_vect_field) || isempty(der_vect_field_theta)
        gradient_use = 0;
    end
    
    
     
    function [res_in res_eq] = mycon(param)
        res_in = 0;
        res_eq = 0;
    end
 
    
      function [res_val res_grad]= func_eco_multi_param(param)
          %param

         nb_param_ci = length(param);
          
         if free_ci ==1
             nb_param = nb_param_ci - dim_syst;
             nv_x_0 = param((nb_param+1):end);
             param_tot = param(1:nb_param);
             nb_ci = dim_syst;
         else
             nb_param = nb_param_ci;
             nv_x_0 = x_0;
             param_tot = param;
             nb_ci = 0;
         end
          
         %nv_x_0
         nb_param = length(param_tot);
        
        
          function dy = equ_b(t,y)
                val_x = reshape(y(1:dim_syst),dim_syst,1); 

                dx = vect_field(t,val_x,param,param_fixe);
                dy = reshape(dx,dim_syst,1);
          end
 
         

        if gradient_use ==0   
         sol_equ =  ode45(@equ_b,Int_ode_solve,reshape(nv_x_0,1,dim_syst));
        end
        
        ind_fin_x_sens_par = dim_syst*nb_param+dim_syst;
        ind_fin_x_sens_x0 = ind_fin_x_sens_par+ dim_syst*dim_syst;

         function dy = equ_sens_tot_b(t,y)
                val_x = reshape(y(1:dim_syst),dim_syst,1); 
                val_x_sens_par = y((dim_syst+1):(ind_fin_x_sens_par));

                val_x_sens_par = reshape(val_x_sens_par,dim_syst,nb_param);
                
                dx = vect_field(t,val_x,param,param_fixe);
                dx_v = reshape(dx,1,dim_syst);

  
                df_theta  = der_vect_field_theta(t,val_x,param_tot,param_fixe);
                df_state  = der_vect_field(t,val_x,param_tot,param_fixe);
                
                d_val_x_sens_par = df_theta+df_state*val_x_sens_par;               
                d_val_x_sens_par_v = reshape(d_val_x_sens_par,1,dim_syst*nb_param);
                
                dy = [dx_v d_val_x_sens_par_v]';
                
                
                if free_ci == 1
                  val_x_sens_x0 = y((ind_fin_x_sens_par+1):(ind_fin_x_sens_x0));
                  val_x_sens_x0 = reshape(val_x_sens_x0,dim_syst,dim_syst);
                  d_val_x_sens_x0 = df_state*val_x_sens_x0;
                  d_val_x_sens_x0_v = reshape(d_val_x_sens_x0,1,dim_syst*dim_syst);
                  dy = [dx_v d_val_x_sens_par_v d_val_x_sens_x0_v]';
                end
         end
          
         
         if gradient_use ==1
             if free_ci == 1
              CI_ini = [reshape(nv_x_0,1,dim_syst) zeros(1,nb_param*dim_syst) reshape(eye(dim_syst),1,dim_syst*dim_syst)] ;   
             else
              CI_ini = [reshape(nv_x_0,1,dim_syst) zeros(1,nb_param*dim_syst)] ;
             end
             sol_equ_sens = ode45(@equ_sens_tot_b,Int_ode_solve,CI_ini);                
         end
         

         
         if gradient_use ==1   
		       matrix_sens = zeros(nb_obs*dim_obs,nb_param+nb_ci);
               val_pred_obs = zeros(nb_obs*dim_obs,1);
			   
               val_pred = deval(sol_equ_sens,Times)';
               res_grad = zeros((nb_param+nb_ci)*gradient_use,1);
               val_pred_x = val_pred(:,1:dim_syst)';
               val_x_sens_p = val_pred(:,(dim_syst+1):ind_fin_x_sens_par);
			    for ni = 1 : length(Times)
                    val_state_ti = val_pred_x(:,ni);
                    val_pred_obs(((ni-1)*dim_obs+1):ni*dim_obs) = mat_c*val_state_ti;
					val_ext_ti = val_x_sens_p(ni,:);	
					matrix_sens(((ni-1)*dim_obs+1):ni*dim_obs,1:nb_param) = mat_c*reshape(val_ext_ti,dim_syst,nb_param);
				end	
               
                 if nb_ci > 0
                    val_x_sens_ci = val_pred(:,(ind_fin_x_sens_par+1):ind_fin_x_sens_x0);
					for ni = 1 : length(Times)
						val_ext_ti = val_x_sens_ci(ni,:);	
						matrix_sens(((ni-1)*dim_obs+1):ni*dim_obs,(nb_param+1):(nb_param+dim_syst)) = mat_c*reshape(val_ext_ti,dim_syst,dim_syst);
				end	
                 end
         else
               val_pred = deval(sol_equ,Times)';    
               val_pred_x = val_pred;
               val_pred_obs = zeros(nb_obs*dim_obs,1);
               
                for ni = 1 : length(Times)
                    val_state_ti = val_pred_x(ni,:);
                    val_pred_obs(((ni-1)*dim_obs+1):ni*dim_obs) = mat_c*val_state_ti';
				end	
         end
             
	       residual = val_pred_obs - Data_mat;

          if gradient_use == 1  
             res_grad= 2*(matrix_sens')*residual;
          end

			res_val = sum(sum(residual.^2));
        end
       

  
  
       if gradient_use == 1
           
           if type_solver == 1
              'fminunc'  
            nb_fun_eval = 300;
            max_iter = 300;

            options = optimset('TolFun',1e-7,'TolX',1e-7,'GradObj','on','MaxFunEvals',nb_fun_eval,'MaxIter',max_iter,'Hessian','off');
            [est_param,fval]= fminunc(@func_eco_multi_param,param_ini,options);
           else
              
               
                    max_iter = 300;
                   nb_fun_eval = 300; 
                   options = optimset('TolFun',1e-7,'TolX',1e-7,'GradObj','on','MaxFunEvals',nb_fun_eval,'MaxIter',max_iter);
                   
                   lb = zeros(length(param_ini),1);
                   ub = zeros(length(param_ini),1);
                   ub(1:length(param_ini)) = +Inf;
                   
                   if type_solver == 3
                        'fmincon Mat_A'
                       Mat_A = -eye(length(param_ini));
                       vect_b = zeros(length(param_ini),1);
                       [est_param,fval] =  fmincon(@func_eco_multi_param,param_ini,Mat_A,vect_b,[],[],lb,ub,@mycon,options)
                   else
                        'fmincon bound'
                        [est_param,fval] =  fmincon(@func_eco_multi_param,param_ini,[],[],[],[],lb,ub,@mycon,options)
                   end
           end
       else
          
          param_ini
       [est_param,fval]= fminsearch(@func_eco_multi_param,param_ini);    

       end
       
        Akaike_score =  dim_obs*nb_obs*log(fval/(dim_obs*nb_obs)) +2*length(est_param);     

end