 % Trace le graphe de la fonction economique 
        %Arguments : 
        %Obs : (Observation) objet contenant les dates d'observations ainsi
        %que les donnes
        % model : (function handler) contient le champ de vecteur correspondant au modele
        % indice : (vecteur de taille 2) indice des 2 parametres  faire varier
        %intervalle (matrice 2*2) contient  chaque ligne l'intervalle de variations des deux paramtres selectionnes
        %theta_fixe : (vecteur) contient la valeur arbitraire fix pour les autres paramtres
        %y0 : (vecteur) contient les valeurs fixes pour les conditions initiales
function paramh= graph_economic_function_nlsode(Obs,model,indice,intervalle,true_param,y0,ind_obs)
        ObsTimes = Obs.getTimes();
        ObsY = Obs.getMatrix();
        dim = length(ObsY);
        
        if nargin < 7
           ind_obs = 1:dim; 
        end
        
        nb_var_obs = length(ind_obs);
        
             intervalle1 = intervalle(1,:);
             intervalle2 = intervalle(2,:);
             
             h1 = (intervalle1(2) - intervalle1(1))/40;
             h2 = (intervalle2(2) - intervalle2(1))/40;
             
             intervalle1 = intervalle1(1):h1:intervalle1(2);
             intervalle2 = intervalle2(1):h2:intervalle2(2);

  
    function res1 = func_eco_aux(theta1,theta2)
        
        theta_complet = true_param;
        theta_complet(indice(1)) = theta1;
        theta_complet(indice(2)) = theta2;

    function dy = c_v(t,y)
        dy = model(t,y,theta_complet);
        dy = reshape(dy,length(dy),1);
    end
    
    [T,Y] = ode45(@c_v,ObsTimes{1},y0);
    res1 = 0;
    for nj = 1 : nb_var_obs
    
    res1 = res1 + sum((Y(:,ind_obs(nj))- ObsY{nj}).^2);
    end
    end

    [X_,Y_] = meshgrid(intervalle1,intervalle2);
    
    Z_ = arrayfun(@func_eco_aux,X_,Y_);
    
    mesh(X_,Y_,Z_);
    
    paramh = Z_;

end