function [paramh,resnorm,residual,COVB,temps_calc]=nv_nlsode(obs,model,theta0,x00,ordre_equ,freeparam)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%
%model : structure of function handler, ode function vf(t,x,theta)
%
%freeparam : 0 = optimize in theta and x0
%            1 = optimize in theta (x0 fixed with input value x0)
%               
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

tic

if nargin < 5
    ordre_equ = 1;
end 

if nargin < 6
    freeparam = 0;
end

p=length(theta0);
d=length(x00);
ObsTimes = obs.getTimes();
ObsY = obs.getMatrix();

opt=optimset('TolX',1e-10,'MaxIter',1e2,'TolFun',1e-10,'MaxFunEvals',1e4);

    if freeparam == 0
        param0=[theta0 x00];
    else
        param0= theta0;
    end
%mysol(param0)
% [paramh,resnorm,residual] = lsqnonlin(@ mysol,param0,[],[],opt);
% 
%     function vecteur_res = mysol(param)
%         %param
%         theta=param(1:p);
%         
%         if freeparam == 0
%         x0  =param(p+1:p+d);
%         else
%             x0 = x00;
%         end
%         
%         function res_int = equ_integ(t,y)
%         res_int =  model(t,y,theta);
%         end
%         
%         pos = 1;
%         
%         iter_dim = d - ordre_equ +1;
%         
%         for jh = 1 : iter_dim
%             
%         Time_sample = ObsTimes{jh};
%         Data_sample = ObsY{jh};
%         [T,Y] = ode15s(@equ_integ,Time_sample,x0);
%         %vecteur_res  = Y - ObsY;
%         vecteur_res(pos : pos+length(Time_sample)-1,1)  = Y(:,jh) - Data_sample;
%         pos = pos + length(Time_sample);
%         end
%         
%     end
    y = cell2mat(ObsY');
    [ligne col] = size(y);
    y = reshape(y,ligne*col,1);
    X = ObsTimes{1};

    [paramh,residual,J,COVB,resnorm] = nlinfit(X,y,@fun_llinfit,param0);
    %[ypred,delta] = nlpredci(@fun_llinfit,X,paramh,residual,'covar',COVB)
    %fun_llinfit(param0,X)
    
    function sol_ode = mysol_altern(param)    
        %param
        theta=param(1:p);
        
        if freeparam == 0
        x0  =param(p+1:p+d);
        else
            x0 = x00;
        end
        
        function res_int = equ_integ(t,y)
        res_int =  model(t,y,theta);
        end

        sol_ode = ode45(@equ_integ,ObsTimes{1},x0);

    end
    
    function res = fun_llinfit(param,t)
        sol_ode = mysol_altern(param);
        res = deval(sol_ode,t)';
        if ordre_equ > 1
        res = res(:,1);
        else
        res = reshape(res,ligne*col,1);
        end
    end
    

temps_calc = toc;
end 