function [sol_linearized val_p_initiale] =  sol_ode_linearized(T_int,x_0,Mat_A,Mat_B,Mat_C,Mat_D,e_x,e_p)
    dim_syst = length(x_0);

    function dy = equ_ode_homogenous(t,y)
        val_x = y(1:(dim_syst^2));
        val_p = y((dim_syst^2+1):(2*dim_syst^2));
        val_x = reshape(val_x,dim_syst,dim_syst); 
        val_p = reshape(val_p,dim_syst,dim_syst);

        dx = Mat_A(t)*val_x+Mat_B(t)*val_p;
        dp = Mat_C(t)*val_x+Mat_D(t)*val_p;
        
        dx_v = reshape(dx,dim_syst^2,1);
        dp_v = reshape(dp,dim_syst^2,1);

        dy = [dx_v' dp_v']';
    end


    
    function dy = equ_ode_particuliere(t,y)
        val_x = y(1:(dim_syst));
        val_p = y((dim_syst+1):(2*dim_syst));
        val_x = reshape(val_x,dim_syst,1); 
        val_p = reshape(val_p,dim_syst,1);
        
        dx = Mat_A(t)*val_x+Mat_B(t)*val_p+e_x(t);
        dp = Mat_C(t)*val_x+Mat_D(t)*val_p+e_p(t);
        
        dx_v = reshape(dx,dim_syst,1);
        dp_v = reshape(dp,dim_syst,1);

        dy = [dx_v' dp_v']';
    end


    C_I_h = [zeros(1,dim_syst^2) reshape(eye(dim_syst),1,dim_syst^2)]';
    sol_hom = ode45(@equ_ode_homogenous,T_int,C_I_h);
    val_finale_hom = deval(sol_hom,T_int(end));
          

            val_x_hom_finale = val_finale_hom(1:(dim_syst^2));
            val_p_hom_finale = val_finale_hom((dim_syst^2+1):(2*dim_syst^2));
            val_x_hom_finale = reshape(val_x_hom_finale,dim_syst,dim_syst); 
            val_p_hom_finale = reshape(val_p_hom_finale,dim_syst,dim_syst);
            
    C_I_par = [x_0' zeros(1,dim_syst)]';
    sol_par = ode45(@equ_ode_particuliere,T_int,C_I_par);
    val_finale_par = deval(sol_par,T_int(end));
          

            val_x_par_finale = val_finale_par(1:(dim_syst));
            val_p_par_finale = val_finale_par((dim_syst+1):(2*dim_syst));
            val_x_par_finale = reshape(val_x_par_finale,dim_syst,1); 
            val_p_par_finale = reshape(val_p_par_finale,dim_syst,1);
            
            val_p_initiale = - inv(val_p_hom_finale)*val_p_par_finale;
            C_I_linearized = [x_0' val_p_initiale']';
            sol_linearized = ode45(@equ_ode_particuliere,T_int,C_I_linearized);
         


end