function [sol_fin Y_est] = ode_solution_estimate_ci(x_0,p_0_est,T_integ,bdpb_vf_state,bdpb_vf_adjoint)

    dim_syst = length(x_0);
    x_0 = reshape(x_0,1,dim_syst);
    p_0_est = reshape(p_0_est,1,dim_syst);


    function dy = lode_entiere(t,y)

            val_x = reshape(y(1:dim_syst),dim_syst,1); 
            val_p = reshape(y((dim_syst+1):2*dim_syst),dim_syst,1); 


            dx = bdpb_vf_state(t,val_x,val_p);
            dp = bdpb_vf_adjoint(t,val_x,val_p);

            dx_v = reshape(dx,dim_syst,1);
            dp_v = reshape(dp,dim_syst,1);

            dy = [dx_v' dp_v']';


    end

    C_I_x_p = [x_0 p_0_est];
     
     sol_fin = ode45(@lode_entiere,T_integ,C_I_x_p);
     Y_est = deval(sol_fin,T_integ)';

end
