

y_init = [10 0 0];
solinit = bvpinit(xinit,y_init);
solbvp = bvp4c(@equ_test_bd_problem,@bnd_constraint,solinit);
val_v = deval(solbvp,0:0.01:10);

plot(0:0.01:10,val_v);


%%  Extremal variation test with linear ODE

T_int = 0:0.1:20;
x_0 = [-1 2];


[sol_equ ci_p res_norm_p_finale] = extremal_variation_algorithm_solver(T_int,x_0,@bdpb_vf_lode_state,@bdpb_vf_lode_adjoint,@bdpb_der_state_wrt_state,@bdpb_der_state_wrt_adjoint,@bdpb_der_adjoint_wrt_state,@bdpb_der_adjoint_wrt_adjoint)

 
 
[sol_fin Y_est] =  ode_solution_estimate_ci(x_0,ci_p,T_int,@bdpb_vf_lode_state,@bdpb_vf_lode_adjoint)
 plot(T_int,Y_est) 
 

 %% Extremal variation Test with scalar linear ode
T_int = 0:0.05:1;
x_0 = 3;


[sol_equ ci_p res_norm_p_finale] = extremal_variation_algorithm_solver(T_int,x_0,@bdpb_vf_scalar_lode_state,@bdpb_vf_scalar_lode_adjoint...
    ,@bdpb_der_scalar_state_wrt_state,@bdpb_der_scalar_state_wrt_adjoint,@bdpb_der_scalar_adjoint_wrt_state,@bdpb_der_scalar_adjoint_wrt_adjoint)

 
 
[sol_fin Y_est] =  ode_solution_estimate_ci(x_0,ci_p,T_int,@bdpb_vf_scalar_lode_state,@bdpb_vf_scalar_lode_adjoint)
 plot(T_int,Y_est) 
 
 
 %% Quasilinearization Test with scalar linear ode
 T_int = 0:0.05:1;
x_0 = 3;

Mat_a = @(t)(-2); 

Mat_b = @(t)(-1);
Mat_c = @(t)(4);
Mat_d = @(t)(3);
e_x = @(t)(6);
e_p = @(t)(0); 
 
% [sol_linearized ci_p] =  sol_ode_linearized(T_int,x_0,Mat_a ,Mat_b,Mat_c,Mat_d,e_x,e_p)

[sol_equ ci_p res_norm_p_finale] = quasilinearization_algorithm_solver(T_int,x_0,@bdpb_vf_scalar_lode_state,@bdpb_vf_scalar_lode_adjoint...
    ,@bdpb_der_scalar_state_wrt_state,@bdpb_der_scalar_state_wrt_adjoint,@bdpb_der_scalar_adjoint_wrt_state,@bdpb_der_scalar_adjoint_wrt_adjoint);


[sol_fin Y_est] =  ode_solution_estimate_ci(x_0,ci_p,T_int,@bdpb_vf_scalar_lode_state,@bdpb_vf_scalar_lode_adjoint);

plot(T_int,Y_est) 

 %% Extremal variation Test with stirred tank
T_int = 0:0.01:0.78;
x_0 = [0.05 0];


[sol_equ ci_p res_norm_p_finale] = extremal_variation_algorithm_solver(T_int,x_0,@bdpb_vf_stirred_tank_state,@bdpb_vf_stirred_tank_adjoint...
    ,@bdpb_der_stirred_tank_state_wrt_state,@bdpb_der_stirred_tank_state_wrt_adjoint,@bdpb_der_stirred_tank_adjoint_wrt_state,@bdpb_der_stirred_tank_adjoint_wrt_adjoint)

 
 
[sol_fin Y_est] =  ode_solution_estimate_ci(x_0,ci_p,T_int,@bdpb_vf_stirred_tank_state,@bdpb_vf_stirred_tank_adjoint);
 plot(T_int,Y_est) 
 
  %% Quasilinearisation Test with stirred tank
T_int = 0:0.01:0.78;
x_0 = [0.05 0];


[sol_equ ci_p res_norm_p_finale] = quasilinearization_algorithm_solver(T_int,x_0,@bdpb_vf_stirred_tank_state,@bdpb_vf_stirred_tank_adjoint...
    ,@bdpb_der_stirred_tank_state_wrt_state,@bdpb_der_stirred_tank_state_wrt_adjoint,@bdpb_der_stirred_tank_adjoint_wrt_state,@bdpb_der_stirred_tank_adjoint_wrt_adjoint)

 
 
[sol_fin Y_est] =  ode_solution_estimate_ci(x_0,ci_p,T_int,@bdpb_vf_stirred_tank_state,@bdpb_vf_stirred_tank_adjoint);
 plot(T_int,Y_est) 
 
 
%% Linear ode data generation
 
 x_0 = 2;
 tr_param = 0.3;
 
deb = 0;
fin = 5;
pas = (fin-deb)/100; 


x0 = 1;
std = 0;

%Data generation
 [T_int res_y ]= lineare_ode_sim(deb,pas,fin,tr_param,x0,std);
 
%Non-parametric estimation 
 Obs_l = Observation(T_int,res_y); 
 bs_l = bSplines(Obs_l,3,x0);
 
%% Test existence solution for linear ode with different a value
lambda = 100;

param_trial = 0.05:0.02:0.5;


for np = 1 : length(param_trial);
    
    param_c = param_trial(np)

 bdpb_vf_scalar_opt_form_lode_state_sp = @(t,vx,vp)(bdpb_vf_scalar_opt_form_lode_state(t,vx,vp,param_c,lambda));
 bdpb_vf_scalar_opt_form_lode_adjoint_sp = @(t,vx,vp)(bdpb_vf_scalar_opt_form_lode_adjoint(t,vx,vp,param_c,bs_l));
 
 bdpb_der_scalar_opt_form_state_wrt_state_sp = @(t,vx,vp)(bdpb_der_scalar_opt_form_state_wrt_state(t,vx,vp,param_c,lambda));
 bdpb_der_scalar_opt_form_state_wrt_adjoint_sp = @(t,vx,vp)(bdpb_der_scalar_opt_form_state_wrt_adjoint(t,vx,vp,param_c,lambda));
 bdpb_der_scalar_opt_form_adjoint_wrt_state_sp = @(t,vx,vp)(bdpb_der_scalar_opt_form_adjoint_wrt_state(t,vx,vp,param_c,lambda));
 bdpb_der_scalar_opt_form_adjoint_wrt_adjoint_sp = @(t,vx,vp)(bdpb_der_scalar_opt_form_adjoint_wrt_adjoint(t,vx,vp,param_c,lambda));
 


% [sol_equ ci_p res_norm_p_finale] = quasilinearization_algorithm_solver(T_int,x_0,bdpb_vf_scalar_opt_form_lode_state_sp,bdpb_vf_scalar_opt_form_lode_adjoint_sp...
%     , bdpb_der_scalar_opt_form_state_wrt_state_sp,bdpb_der_scalar_opt_form_state_wrt_adjoint_sp,bdpb_der_scalar_opt_form_adjoint_wrt_state_sp,bdpb_der_scalar_opt_form_adjoint_wrt_adjoint_sp);


[sol_equ ci_p res_norm_p_finale] = extremal_variation_algorithm_solver(T_int,x_0,bdpb_vf_scalar_opt_form_lode_state_sp,bdpb_vf_scalar_opt_form_lode_adjoint_sp...
    , bdpb_der_scalar_opt_form_state_wrt_state_sp,bdpb_der_scalar_opt_form_state_wrt_adjoint_sp,bdpb_der_scalar_opt_form_adjoint_wrt_state_sp,bdpb_der_scalar_opt_form_adjoint_wrt_adjoint_sp);


     ci_p 
     res_norm_p_finale

end

[sol_fin Y_est] =  ode_solution_estimate_ci(x_0,ci_p,T_int,bdpb_vf_scalar_opt_form_lode_state_sp,bdpb_vf_scalar_opt_form_lode_adjoint_sp);
 plot(T_int,Y_est) 
 
%% plot func eco simplest linear case der_x = ax, x0 known

 
 x0 = 2;
 tr_param = 0.3;
 
deb = 0;
fin = 5;
pas = (fin-deb)/100; 


std = 0;

%Data generation
 [T_int res_y ]= lineare_ode_sim(deb,pas,fin,tr_param,x0,std);
 
%Non-parametric estimation 
 Obs_l = Observation(T_int,res_y); 
 bs_l = bSplines(Obs_l);
 bs_l.erreur(1)

 
mat_model = @(time,par,par_f)(par);
mat_obs_c = 1;
mat_U = 100;
param_trial_plot = [0.05 0.5;];

res_fval = plot_func_eco_pontryagin_linear_case(bs_l,mat_model,mat_obs_c,mat_U,param_trial_plot,x0)

%res_fval= plot_func_eco_pontryagin_general_case(bs_l,@vect_field_scalar_linear_ode,@der_vect_field_scalar_linear_ode,@der_sec_vect_field_scalar_linear_ode,mat_obs_c,mat_U,param_trial_plot,x0)

%plot_func_eco_pontryagin_general_case_integ_inv(bs_l,@vect_field_scalar_linear_ode,@der_vect_field_scalar_linear_ode,mat_obs_c,mat_U,param_trial_plot,res_y(end))
figure
res_fval = plot_func_eco_pontryagin_bvp4c(bs_l,@vect_field_scalar_linear_ode,@der_vect_field_scalar_linear_ode,mat_obs_c,mat_U,param_trial_plot,x0)
%% plot 
deb = 0;
fin = 100;
pas = (fin-deb)/100;
x_0_banga = [100 0 0 0 0];
theta_banga = 1000*[0.0000593 0.0000296 0.0000205 0.000275 0.00004];
%lambda_trial= [20:20:200 300:100:1000 5000 10000];
lambda_trial = [5*10^5 10^6 5*10^6 10^7 5*10^7 10^8 10^9 10^10 10^11];

%Data generation
[T1 Y1] = FBA_gen_sim(deb,fin,pas,[theta_banga x_0_banga],0);
 Obs_l = Observation(T1,Y1); 
 bs_l = bSplines(Obs_l,3,x_0_banga);
%bs_l.erreur(1)

mat_model = @a_pinene_2param_pontryagin;
mat_obs_c = eye(5);
mat_U = 1000*eye(5);
param_trial_plot = [0.5*theta_banga(1) 1.5*theta_banga(1);0.5*theta_banga(2) 1.5*theta_banga(2)];



res_fval = plot_func_eco_pontryagin_linear_case(bs_l,mat_model,mat_obs_c,mat_U,param_trial_plot,x_0_banga,theta_banga(3:5),1)



%%
clear
deb = 0;
fin = 10;
pas = (fin-deb)/100;
param_vect = [0.2 0.5];
x_0 = [1 0.5];
std = 0.0

[T1 Y1] = modele_lineaire_mat_dim2(deb,fin,pas,x_0,param_vect,std );

Obs_l = Observation(T1,Y1); 
bs_l = bSplines(Obs_l,3,x_0);
%bs_l.erreur(1)
 
mat_model = @ mat_2dim;
mat_obs_c = eye(2);
mat_U = 10000*eye(2);
param_trial_plot = [0.5*param_vect(1) 1.5*param_vect(1);0.5*param_vect(2) 1.5*param_vect(2)];



res_fval = plot_func_eco_pontryagin_linear_case(bs_l,mat_model,mat_obs_c,mat_U,param_trial_plot,x_0)
figure
%res_fval= plot_func_eco_pontryagin_general_case(bs_l,@vect_field_mat2dim_lode,@der_vect_field_mat2dim_lode,@der_sec_vect_field_mat2dim_lode,mat_obs_c,mat_U,param_trial_plot,x_0)

 plot_func_eco_pontryagin_general_case_integ_inv(bs_l,@vect_field_mat2dim_lode,@der_vect_field_mat2dim_lode,mat_obs_c,mat_U,param_trial_plot,bs_l.calcul_prediction(T1(end)))
 figure
 res_fval = plot_func_eco_pontryagin_bvp4c(bs_l,@vect_field_mat2dim_lode,@der_vect_field_mat2dim_lode,mat_obs_c,mat_U,param_trial_plot,x_0)
 
%% plot func eco non linear scalar model

deb = 0;
fin = 20;
pas = (fin-deb)/100;
param = 2;
x_0 = 2;
std = 0;


[T1 Y1] = modele_non_lineaire_scalaire(deb,fin,pas,x_0,param,std)
[T1_tr Y1_tr] = modele_non_lineaire_scalaire(deb,fin,pas,x_0,param,0)

Obs_l = Observation(T1,Y1); 
bs_l = bSplines(Obs_l,3,x_0);
%bs_l.erreur(1)

truefinale_value = Y1_tr(end)

mat_obs_c = 1;
mat_U = 10^15;
%param_trial_plot = [0.5*param 1.5*param; 0.5*truefinale_value 1.5*truefinale_value];
param_trial_plot = [0.5*param 1.5*param;];
solver_type =0;


res_fval= plot_func_eco_pontryagin_general_case(bs_l,@vect_field_scalaire_nl,@der_vect_field_scalaire_nl,@der_sec_vect_field_scalaire_nl,...
    mat_obs_c,mat_U,param_trial_plot,x_0,[],solver_type)
figure
res_fval = plot_func_eco_pontryagin_general_case_integ_inv(bs_l,@vect_field_scalaire_nl,@der_vect_field_scalaire_nl,mat_obs_c,mat_U,param_trial_plot,truefinale_value)
figure
res_fval = plot_func_eco_pontryagin_bvp4c(bs_l,@vect_field_scalaire_nl,@der_vect_field_scalaire_nl,mat_obs_c,mat_U,param_trial_plot,x_0)

%% plot func eco non linear scalar model 2eme

deb = 0;
fin = 20;
pas = (fin-deb)/100;
param = 2;
x_0 = 2;
std = 0.2;



[T1 Y1] = modele_non_lineaire_scalaire_2eme(deb,fin,pas,x_0,param,std)
[T1_tr Y1_tr] = modele_non_lineaire_scalaire_2eme(deb,fin,pas,x_0,param,0);

Obs_l = Observation(T1,Y1); 
bs_l = bSplines(Obs_l,3,x_0);
bs_l.erreur(1)

truefinale_value = Y1_tr(end)

mat_obs_c = 1;
mat_U = 10^40;
%param_trial_plot = [0.8*param 1.15*param; 0.8*truefinale_value 1.15*truefinale_value];
param_trial_plot = [0.8*param 1.15*param];
solver_type =1;


%  res_fval= plot_func_eco_pontryagin_general_case(bs_l,@vect_field_scalaire_nl,@der_vect_field_scalaire_nl,@der_sec_vect_field_scalaire_nl,...
%      mat_obs_c,mat_U,param_trial_plot,x_0,[],solver_type)
%figure
res_fval = plot_func_eco_pontryagin_general_case_integ_inv(bs_l,@vect_field_scalaire_nl_2eme,@der_vect_field_scalaire_nl_2eme,mat_obs_c,mat_U,param_trial_plot,truefinale_value)
figure
res_fval = plot_func_eco_pontryagin_bvp4c(bs_l,@vect_field_scalaire_nl_2eme,@der_vect_field_scalaire_nl_2eme,mat_obs_c,mat_U,param_trial_plot,x_0)



%% plot func eco fitz hugh

deb=0;
fin=20;
h_var = 0.02;

x_0= [-1 1];
a = 0.2;
b = 0.2;
c = 3;

std = 0;

theta = [a b c];

 [T1 Y1] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,std);
 [T1_tr Y1_tr] = fitz_nagumo(deb,fin,h_var,x_0,a,b,c,0);
  
  Obs1 = Observation(T1,Y1);
  bs1 = bSplines(Obs1,3,x_0);
  bs1.erreur(1);

truefinale_value = Y1_tr(length(T1_tr),:)
mat_obs_c = eye(2);
lambda =(10^10) ;
mat_U = lambda*eye(2);
param_trial_plot = [0.2 1.5*a;0.2 1.5*b];
  
%  solver_type =1; 
%   res_fval= plot_func_eco_pontryagin_general_case(bs1,@vect_field_fitzHugh,@der_vect_field_fitzHugh,@der_sec_vect_field_fitzHugh,...
%     mat_obs_c,mat_U,param_trial_plot,x_0,c,solver_type)
% 
% 

%res_fval = plot_func_eco_pontryagin_general_case_integ_inv(bs1,@vect_field_fitzHugh,@der_vect_field_fitzHugh,mat_obs_c,mat_U,param_trial_plot,truefinale_value,c)